<?php
/**
 *    @version 2.1.1 Build 21106 Alpha [ Drury ]
 *    @package hwdVideoShare
 *    @copyright (C) 2007 - 2009 Highwood Design
 *    @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 ***
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

if (!defined('_CB_NOTRIM')) { define('_CB_NOTRIM', 0x0001); }
if (!defined('_CB_ALLOWRAW')) { define('_CB_ALLOWRAW', 0x0004); }

class hwdvids_BE_plugins
{
   /**
	*/
	function cbGetParam( &$arr, $name, $def=null, $mask=0 ) {
		static $noHtmlFilter = null;
		// static $safeHtmlFilter = null;

		if ( isset( $arr[$name] ) ) {
			if ( is_array( $arr[$name] ) ) {
				$ret			=	array();
				foreach ( $arr[$name] as $k => $v ) {
					$ret[$k]	=	hwdvids_BE_plugins::cbGetParam( $arr[$name], $k, $def, $mask);
				}
			} else {
				$ret			=	$arr[$name];
				if ( is_string( $ret ) ) {
					if ( ! ( $mask & _CB_NOTRIM ) ) {
						$ret	=	trim( $ret );
					}
					if ( ! ( $mask & _CB_ALLOWRAW ) ) {
						if ( is_null( $noHtmlFilter ) ) {
							if ( class_exists( "InputFilter" ) ) {		// Mambo 4.5.0 compatibility
								$noHtmlFilter = new InputFilter( /* $tags, $attr, $tag_method, $attr_method, $xss_auto */ );
							} else {
								$noHtmlFilter = new hwdvshtmlfilterold;
							}
						}
						$ret	=	$noHtmlFilter->process( $ret );
					}
					if ( is_int( $def ) ) {
						$ret	=	(int) $ret;
					} elseif ( !  get_magic_quotes_gpc() ) {
						$ret	=	addslashes( $ret );
					}
				}
			}
			return $ret;
		} else {
			return $def;
		}
	}
   /**
	*/
	function uploadFile( $filename, $userfile_name, &$msg ) {
		global $mainframe;
		$baseDir = JPath::clean( JPATH_SITE . '/media/' );
		if (file_exists( $baseDir )) {
			if (is_writable( $baseDir )) {
				if (move_uploaded_file( $filename, $baseDir . $userfile_name )) {
					if ((!is_callable("mosChmod")) or mosChmod( $baseDir . $userfile_name )) {		// mambo 4.5.1 support
						return true;
					} else {
						$msg = 'Failed to change the permissions of the uploaded file.';
					}
				} else {
					$msg = 'Failed to move uploaded file to <code>/media</code> directory.';
				}
			} else {
				$msg = 'Upload failed as <code>/media</code> directory is not writable.';
			}
		} else {
			$msg = 'Upload failed as <code>/media</code> directory does not exist.';
		}
		return false;
	}
   /**
	* view the plugin page
	*/
	function showPlugins( $option ) {
		global $database, $mainframe, $mosConfig_list_limit;
  		$db =& JFactory::getDBO();

		if(!isset($mosConfig_list_limit) || !$mosConfig_list_limit) $limit = 10;
		else $limit = $mosConfig_list_limit;
		$limit 			= $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', $limit );
		$lastCBlist = $mainframe->getUserState( "view{$option}lastCBlist", null );
		if ($lastCBlist == 'showplugins') {
			$limitstart 	= $mainframe->getUserStateFromRequest( "view{$option}limitstart", 'limitstart', 0 );
			$lastSearch = $mainframe->getUserState( "search{$option}", null );
			$search		= $mainframe->getUserStateFromRequest( "search{$option}", 'search', '' );
			if ($lastSearch != $search) {
				$limitstart = 0;
				$mainframe->setUserState( "view{$option}limitstart", $limitstart );
			}
			$search = trim( strtolower( $search ) );
			$filter_type	= $mainframe->getUserStateFromRequest( "filter_type{$option}", 'filter_type', "0" );
		} else {
			$search="";
			$limitstart = 0;
			$mainframe->setUserState( "view{$option}limitstart", $limitstart );
			$mainframe->setUserState( "view{$option}lastCBlist", "showplugins" );
			$filter_type = "0";
			$mainframe->setUserState( "filter_type{$option}", $filter_type );
		}
		$where=array();

		// used by filter
		if ( $filter_type ) {
			$where[] = "m.type = '$filter_type'";
		}
		if ( $search ) {
			$search = Jrequest::getVar( 'search', '' );
			//$search = cbEscapeSQLsearch( trim( strtolower( cbGetEscaped($search))));
			$where[] = "LOWER( m.name ) LIKE '%$search%'";
		}

		// get the total number of records
		$query = "SELECT COUNT(*) FROM #__hwdvidsplugin AS m ". ( count( $where ) ? "\n WHERE " . implode( ' AND ', $where ) : '' );
		$db->setQuery( $query );
		$total = $db->loadResult();
		if ($total <= $limitstart) $limitstart = 0;

		require_once( JPATH_SITE. "/administrator/includes/pageNavigation.php" );
		$pageNav = new mosPageNav( $total, $limitstart, $limit );

		$query = "SELECT m.*, u.name AS editor, g.name AS groupname"
		. "\n FROM #__hwdvidsplugin AS m"
		. "\n LEFT JOIN #__users AS u ON u.id = m.checked_out"
		. "\n LEFT JOIN #__groups AS g ON g.id = m.access"
		. ( count( $where ) ? "\n WHERE " . implode( ' AND ', $where ) : '' )
		. "\n GROUP BY m.id"
		. "\n ORDER BY m.type ASC, m.ordering ASC, m.name ASC"
		. "\n LIMIT " . (int) $pageNav->limitstart . ", " . (int) $pageNav->limit
		;
		$db->setQuery( $query );
		$rows = $db->loadObjectList();
		if ($db->getErrorNum()) {
			echo $db->stderr();
			return false;
		}

		// get list of Positions for dropdown filter
		$query = "SELECT type AS value, type AS text"
		. "\n FROM #__hwdvidsplugin"
		. "\n GROUP BY type"
		. "\n ORDER BY type"
		;
		$types[] = JHTML::_('select.option', '0', (!defined('_SEL_TYPE')) ? '- Select Type -' : _SEL_TYPE);
		$db->setQuery( $query );
		$types = array_merge( $types, $db->loadObjectList() );
		$lists['type']	= JHTML::_('select.option', $types, 'filter_type', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', $filter_type);

		hwdvids_HTML::showPlugins( $rows, $pageNav, $option, $lists, $search );
		return true;
	}
   /**
	*/
	function installPluginUpload() {
		global $mainframe,$_FILES;

		hwdvids_HTML::showInstallMessage( "", "", "" );
	}
	/**
	* Deletes one or more plugins
	*
	* Also deletes associated entries in the #__hwdvidsplugin table.
	* @param array An array of unique category id numbers
	*/
	function removePlugin( &$cid, $option ) {
		global $database, $my;

		if (count( $cid ) < 1) {
			echo "<script type=\"text/javascript\"> alert('Select a plugin to delete'); window.history.go(-1);</script>\n";
			exit;
		}
		include_once(JPATH_SITE."/administrator/components/com_hwdvideoshare/plugin.foundation.php");
		include_once(JPATH_SITE."/administrator/components/com_hwdvideoshare/library/cb/cb.installer.php");
		$installer = new cbInstallerPlugin();
		foreach($cid AS $id) {
			if ($id == 1) {
				echo "<script type=\"text/javascript\"> alert('The GoogleVideo plugin is a core plugin and can not be uninstalled. Unpublish it if you do not want to use it. Update hwdVideoShare to get the latest version.'); window.history.go(-1);</script>\n";
				exit;
			} else if ($id == 2) {
				echo "<script type=\"text/javascript\"> alert('The YouTube plugin is a core plugin and can not be uninstalled. Unpublish it if you do not want to use it. Update hwdVideoShare to get the latest version.'); window.history.go(-1);</script>\n";
				exit;
			} else if ($id == 3) {
				echo "<script type=\"text/javascript\"> alert('The Backend Remote Server Support plugin is a core plugin and can not be uninstalled. Unpublish it if you do not want to use it. Update hwdVideoShare to get the latest version.'); window.history.go(-1);</script>\n";
				exit;
			} else if ($id == 5) {
				echo "<script type=\"text/javascript\"> alert('The OS FLV Player plugin is a core plugin and can not be uninstalled. Unpublish it if you do not want to use it. Update hwdVideoShare to get the latest version.'); window.history.go(-1);</script>\n";
				exit;
			}
			$ret=$installer->uninstall($id,$option);
		}

		hwdvids_HTML::showInstallMessage( $installer->getError(), 'Uninstall Plugin - '.($ret ? 'Success' : 'Failed'),
		$installer->returnTo( $option, 'templates' ) );
	}
	/**
	* Publishes or Unpublishes one or more plugins
	* @param array An array of unique category id numbers
	* @param integer 0 if unpublishing, 1 if publishing
	*/
	function publishPlugin( $cid=null, $publish=1, $option ) {
		global $mainframe, $my;
		$db = & JFactory::getDBO();

		if (count( $cid ) < 1) {
			$action = $publish ? 'publish' : 'unpublish';
			echo "<script type=\"text/javascript\"> alert('Select a plugin to $action'); window.history.go(-1);</script>\n";
			exit;
		}

		if (is_callable("mosArrayToInts")) {
			mosArrayToInts($cid);
		}
		$cids = implode( ',', $cid );

		$query = "UPDATE #__hwdvidsplugin SET published = " . (int) $publish
		. "\n WHERE id IN ($cids)"
		. "\n AND ((checked_out = 0) OR (checked_out = " . (int) $my->id . "))"
		;
		$db->setQuery( $query );
		if (!$db->query()) {
			echo "<script type=\"text/javascript\"> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
			exit();
		}

		if (count( $cid ) == 1) {
			$row = new hwdvidsplugin( $db );
			$row->checkin( $cid[0] );
		}
		$mainframe->redirect( JURI::root( true ) . '/administrator/index2.php?option=com_hwdvideoshare&task=plugins' );
	}
   /**
	* cancel videos
	*/
	function cancelPlugin($option)
	{
		global $mainframe;
		$db = & JFactory::getDBO();

		$row = new hwdvidsplugin( $db );
		$row->bind( $_POST );
		$row->checkin();

		$mainframe->redirect( JURI::root( true ) . '/administrator/index2.php?option='.$option.'&task=plugins' );

	}
/**
* Saves the CB plugin after an edit form submit
*/
function savePlugin( $option ) {
	global $database, $mainframe, $task, $_PLUGINS;
	$db = & JFactory::getDBO();
	if ( $task == 'showPlugins' ) {
		cbRedirect( 'index2.php?option=' . $option . '&task=showPlugins');
		return;
	}

	$action = hwdvids_BE_plugins::cbGetParam( $_REQUEST, 'action' );

	if ( ! $action ) {
		hwdvids_BE_plugins::savePluginParams( $option, $task );
	} else {
		$uid	= cbGetParam( $_REQUEST, 'cid' );
		$row 	= new hwdvidsplugin($db);
		if ( $uid ) {
			$row->load( (int) $uid );
		}

		// get params values
		if ($row->type !== "language") {
			$_PLUGINS->loadPluginGroup($row->type,array($row->id), 0);
		}
		// xml file for plugin
		$element	=& _loadPluginXML( $row, 'action', $action );

		$_REQUEST['task'] = 'editPlugin';		// so that the actionPath matches
		$params =& new hwdvsparamsbase( $row->params );
		editPluginView( $row, $option, 'editPlugin', $uid, $action, $element, $task, $params );
	}
}
/**
* Saves the CB plugin params after an edit form submit
*/
function savePluginParams( $option, $task ) {
	global $database, $mainframe, $_POST;
	$db = & JFactory::getDBO();

		include_once(JPATH_SITE."/administrator/components/com_hwdvideoshare/plugin.foundation.php");
		include_once(JPATH_SITE."/administrator/components/com_hwdvideoshare/library/cb/cb.params.php");

 	$_POST['params'] = cbParamsEditorController::getRawParams( $_POST['params'] );

	$row = new hwdvidsplugin( $db );
	if (!$row->bind( $_POST )) {
		echo "<script type=\"text/javascript\"> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->check()) {
		echo "<script type=\"text/javascript\"> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->store()) {
		echo "<script type=\"text/javascript\"> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}
	$row->checkin();

	switch ( $task ) {
		case 'applyPlugin':
			$msg = 'Successfully Saved changes to Plugin: '. $row->name;
			$mainframe->enqueueMessage($msg);
			$mainframe->redirect( JURI::root( true ) . '/administrator/index2.php?option='. $option .'&task=editPlugin&cid='. $row->id );

		case 'savePlugin':
		default:
			$msg = 'Successfully Saved Plugin: '. $row->name;
			$mainframe->enqueueMessage($msg);
			$mainframe->redirect( JURI::root( true ) . '/administrator/index2.php?option=com_hwdvideoshare&task=plugins' );
			break;
	}
}











	/**
	* Compiles information to add or edit a plugin
	* @param string The current GET/POST option
	* @param integer The unique id of the record to edit
	*/
	function editPlugin( $option, $task, $uid) {
		global $database, $my, $mainframe, $_PLUGINS, $_POST;
		$db = & JFactory::getDBO();

		include_once(JPATH_SITE."/administrator/components/com_hwdvideoshare/library/cb/cb.params.php");
		include_once(JPATH_SITE."/administrator/components/com_hwdvideoshare/library/cb/xml/cb.xml.simplexml.php");

		if (!isset($uid)) {
		$uid 	= JRequest::getInt( 'plugid', 0 );
		}
		$action	= hwdvids_BE_plugins::cbGetParam( $_REQUEST, 'action', null );

		if ( ! $uid ) {
			$uid = hwdvids_BE_plugins::cbGetParam( $_POST, 'id' );
		}

		$row 	= new hwdvidsplugin($db);
		if ( $uid ) {
			// load the row from the db table
			$row->load( (int) $uid );
		}

		// fail if checked out not by 'me'
		//if ($row->checked_out && $row->checked_out <> $my->id) {
		//	echo "<script type=\"text/javascript\">alert('The plugin $row->name is currently being edited by another administrator'); document.location.href='index2.php?option=$option'</script>\n";
		//	exit(0);
		//}

		// get params values
		if ( $row->type !== "language" && $row->id ) {
			$_PLUGINS->loadPluginGroup($row->type,array($row->id), 0);
		}

		// xml file for plugin
		$element = null;
		if ($uid) {
			$element	=& hwdvids_BE_plugins::_loadPluginXML( $row, 'action', $action );
		}

		if ( $action === null ) {
			$adminActionsModel	=& $element->getChildByNameAttr( 'actions', 'ui', 'admin' );


			if ( $adminActionsModel ) {
				$defaultAction	=& $adminActionsModel->getChildByNameAttr( 'action', 'name', 'default' );
				$actionRequest	=	$defaultAction->attributes( 'request' );
				$actionAction	=	$defaultAction->attributes( 'action' );
				if ( ( $actionRequest === '' ) && ( $actionRequest === '' ) ) {
					$action = '';
				}
			}
		}
		$description			=& $element->getChildByNameAttributes( 'description' );

		if ( $description ) {
			$row->description	=	$description->data();
		} else {
			$row->description	=	'-';
		}
		if ( $action === null ) {
			$params =& new cbParamsEditorController( $row->params, $element, $element, $row );
			$options = array( 'option' => $option, 'task' => $task, 'pluginid' => $uid, 'tabid' => null );
			$params->setOptions( $options );
			hwdvids_BE_plugins::editPluginSettingsParams( $row, $option, $task, $uid, $element, $params, $options );

		} else {
			$params =& new hwdvsparamsbase( $row->params );
			editPluginView( $row, $option, $task, $uid, $action, $element, 'editPlugin', $params );

		}
	}
function editPluginSettingsParams( &$row, $option, $task, $uid, &$element, &$params, &$options ) {
	$db = & JFactory::getDBO();
	$my = & JFactory::getUser();

	$lists 	= array();

	// get list of groups
	if ($row->access == 99 || $row->client_id == 1) {
		$lists['access'] = 'Administrator<input type="hidden" name="access" value="99" />';
	} else {
		// build the html select list for the group access
		if (is_callable(array("mosAdminMenus","Access"))) {
			$lists['access'] 		= mosAdminMenus::Access( $row );
		} else {
			/* Mambo 4.5.0 support: */
			$db->setQuery( 'SELECT id AS value, name AS text FROM #__groups ORDER BY id' );
			$lists['access'] = JHTML::_('select.genericlist', $db->loadObjectList(), 'access', 'class="inputbox" size="3"', 'value', 'text', intval( $row->access ));
		}
	}

	if ($uid) {
		$row->checkout( $my->id );

		if ( $row->ordering > -10000 && $row->ordering < 10000 ) {
			// build the html select list for ordering
			$query = "SELECT ordering AS value, name AS text"
			. "\n FROM #__hwdvidsplugin"
			. "\n WHERE type='" . $db->getEscaped( $row->type ) . "'"
			. "\n AND published > 0"
			. "\n AND ordering > -10000"
			. "\n AND ordering < 10000"
			. "\n ORDER BY ordering"
			;
			$order = JHTML::_('list.genericordering', $query);
			$lists['ordering'] = JHTML::_('select.genericlist', $order, 'ordering', 'class="inputbox" size="1"', 'value', 'text', intval( $row->ordering ));
		} else {
			$lists['ordering'] = '<input type="hidden" name="ordering" value="'. $row->ordering .'" />This plugin cannot be reordered';
		}
		$lists['type'] = '<input type="hidden" name="type" value="'. $row->type .'" />'. $row->type;

		if ($element && $element->name() == 'cbinstall' && $element->attributes( 'type' ) == 'plugin' ) {
			$description =& $element->getElementByPath( 'description' );
			$row->description = ( $description ) ? trim( $description->data() ) : '';
		}

	} else {
		$row->folder 		= '';
		$row->ordering 		= 999;
		$row->published 	= 1;
		$row->description 	= '';

		$folders = mosReadDirectory( JPATH_SITE . '/hwdvideos/plugin/' );
		$folders2 = array();
		foreach ($folders as $folder) {
		    if (is_dir( JPATH_SITE . '/hwdvideos/plugin/' . $folder ) && ( $folder <> 'CVS' ) ) {
		        $folders2[] = JHTML::_('select.option', $folder);
			}
		}
		$lists['type'] = JHTML::_('select.genericlist', $folders2, 'type', 'class="inputbox" size="1"', 'value', 'text', null);
		$lists['ordering'] = '<input type="hidden" name="ordering" value="'. $row->ordering .'" />New items default to the last place. Ordering can be changed after this item is saved.';
	}

	$Yesoptions = array();
	$Yesoptions[] = JHTML::_('select.option', '1', _ADMIN_HWDVIDS_SETT_YES);
	if ($row->type == "language") {
		$row->published = '1';
	} else {
		$Yesoptions[] = JHTML::_('select.option', '0', _ADMIN_HWDVIDS_SETT_NO);
	}
	if (is_callable(array("mosHTML","radioList"))) {			// mambo 4.5.0 compatibility:
		$lists['published'] = JHTML::_('select.radiolist', $Yesoptions, 'published', 'class="inputbox"', $row->published);
	} else {
		$lists['published'] = JHTML::_('select.genericlist', $Yesoptions, 'published', 'class="inputbox"', 'value', 'text', $row->published);
	}

	hwdvids_HTML::editPlugin( $row, $lists, $params, $options );
}
/**
 * xml file for plugin
 *
 * @param  comprofilerPlugin  $row
 * @param  string             $actionType
 * @param  string             $action
 * @return CBSimpleXMLElement
 */
function & _loadPluginXML( &$row, $actionType, $action ) {
	global $mainframe, $_PLUGINS;

		include_once(JPATH_SITE."/administrator/components/com_hwdvideoshare/library/cb/cb.params.php");
		include_once(JPATH_SITE."/administrator/components/com_hwdvideoshare/library/cb/xml/cb.xml.simplexml.php");

	$element = null;
	$xmlString	=	null;

	// security sanitization to disable use of `/`, `\\` and `:` in $action variable
	$unsecureChars		=	array( '/', '\\', ':', ';', '{', '}', '(', ')', "\"", "'", '.', ',', "\0", ' ', "\t", "\n", "\r", "\x0B" );
	$classname			=	'CBplug_' . strtolower( substr( str_replace( $unsecureChars, '', $row->element ), 0, 32 ) );
	$action_cleaned		=				strtolower( substr( str_replace( $unsecureChars, '', $action ),		  0, 32 ) );

	if ( class_exists( $classname ) && is_callable( array( $classname, 'loadAdmin' ) ) ) {
		$array			=	array( );
		$_PLUGINS->call( $row->id, 'loadAdmin', $classname, $array, null, true );

		if ( is_callable( array( $classname, 'getXml' ) ) ) {
			// $xmlString	=	$pluginClass->getXml( 'action', $action_cleaned );
			$array		=	array( $actionType, $action_cleaned );
			$xmlString	=	$_PLUGINS->call( $row->id, 'getXml', $classname, $array, null, true );
		}
	}
	if ( ! $xmlString && $action_cleaned ) {
		$xmlfile = JPATH_SITE . '/hwdvideos/plugin/' .$row->type . '/'.$row->folder . '/xml/edit.' . $actionType . '.' . $action_cleaned .'.xml';
		if ( file_exists( $xmlfile ) ) {
			$xmlString = trim( file_get_contents( $xmlfile ) );
		}
	}
	if ( ! $xmlString ) {
		$xmlfile = JPATH_SITE . '/hwdvideos/plugin/' .$row->type . '/'.$row->folder . '/xml/edit.plugin.xml';
		if ( file_exists( $xmlfile ) ) {
			$xmlString = trim( file_get_contents( $xmlfile ) );
		}
	}
	if ( ! $xmlString ) {
		$xmlfile = JPATH_SITE . '/hwdvideos/plugin/' .$row->type . '/'.$row->folder . '/' . $row->element .'.xml';
		if ( file_exists( $xmlfile ) ) {
			$xmlString = trim( file_get_contents( $xmlfile ) );
		}
	}
	if ( ! $xmlString ) {
		$row->description = '<b><font style="color:red;">Plugin not installed</font></b>';
	} else {
		//TBD if ( cbStartOfStringMatch( $xmlString, '@import ') ...

		hwdvsimport('cb.xml.simplexml');
		$element =& new CBSimpleXMLElement( $xmlString );
	}
	return $element;
}


}

class hwdvshtmlfilterold {
	function process($string) {
		return strip_tags( $string );
	}
}


/** CORRECTION FOR OLD-STYLE TEMPLATES:
*/
/**
* Outputs once an arbitrary html text into head tags if possible and configured, otherwise echo it.
* @param string html text for header
*/
function addhwdvsheadtag($ui,$text) {
	global $mainframe, $ueConfig, $_CB_outputedHeads;
	if ( ! in_array( $text, $_CB_outputedHeads) ) {
		$_CB_outputedHeads[] = $text;
		if ($ui==1 && method_exists($mainframe,"addCustomHeadTag") && isset($ueConfig['xhtmlComply']) && $ueConfig['xhtmlComply']) {
			$mainframe->addCustomHeadTag($text);
		} else {
			echo $text . "\n";
		}
	}
}

/**
 * offsets date-time if time is present and $serverTimeOffset 1, then formats to CB's configured date-time format.
 *
 * @param mixed		string $date in "Y-m-d H:i:s" format, or 	int : unix timestamp
 * @param int $serverTimeOffset : 0: don't offset, 1: offset if time also in $date
 * @param boolean $showtime : false don't show time even if time is present in string
 * @return string date formatted
 */
function hwdvsFormatDate( $date, $serverTimeOffset = 1, $showtime=true ) {
	global $ueConfig;

	if ( is_int( $date ) ) {
		$date = date( ($showtime) ? "Y-m-d H:i:s" : "Y-m-d", $date );
	}
	if ( ( $date!='' ) && ( $date != null ) && ( $date != '0000-00-00 00:00:00' ) && ( $date != '0000-00-00' ) ) {
		if ( strlen( $date ) > 10 ) {
			if ( ( $serverTimeOffset == 1 ) ) {
				$date = mosFormatDate( $date, (($showtime) ? "%Y-%m-%d %H:%M:%S" : "%Y-%m-%d" ) );		// offsets datetime with server offset setting
			} else {
				$date = substr( $date, 0, 10 );
			}
		}
		$ret = hwdvsDateConverter( $date, 'Y-m-d', $ueConfig['date_format'] );
	} else {
		$ret = "";
	}
	return $ret;
}
function hwdvsDateConverter($oDate,$oFromFormat,$oToFormat) {
	if($oDate=="" || $oDate == null || !isset($oDate)) {
		return "";
	} else {
		$specChar = array(".","/");
		$oDate = str_replace($specChar,"-",$oDate);
		$oFromFormat = str_replace($specChar,"-",$oFromFormat);
		$oDate=explode(" ",$oDate);
		if (!ISSET($oDate[1])) $oDate[1]="";
		$dateParts=explode ("-", $oDate[0] );
		$fromParts=explode( "-", $oFromFormat );

		$dateArray = array();
		$dateArray[$fromParts[0]] = $dateParts[0];
		$dateArray[$fromParts[1]] = $dateParts[1];
		$dateArray[$fromParts[2]] = $dateParts[2];

		if (strpos($oToFormat,"/")!=false) $char = "/";
		elseif (strpos($oToFormat,".")!=false) $char = ".";
		else $char = "-";

		$toParts=explode( $char, $oToFormat );

		$returnDate=$oToFormat;
		foreach ($toParts as $toPart) {
			if ($toPart=='Y' || $toPart=='y') {
				if ( array_key_exists( $toPart, $dateArray ) ) {
					$returnDate		=	str_replace($toPart,$dateArray[$toPart],$returnDate);
				} elseif ( $toPart == 'y' ) {
					$returnDate		=	str_replace($toPart,substr($dateArray['Y'],-2),$returnDate);
				} else {
					$returnDate		=	str_replace($toPart,$dateArray['y'],$returnDate);
				}
			}else {
				$returnDate=str_replace($toPart,substr($dateArray[$toPart],0,2),$returnDate);
			}
		}
		return $returnDate. ( ( $oDate[1] != "" ) ? " ".$oDate[1] : "" );
	}

}

class moshwdvsHTML extends JHTML {

	function radioListArr( &$arr, $tag_name, $tag_attribs, $key, $text, $selected, $required=0 ) {
		reset( $arr );
		$html = array();
		for ($i=0, $n=count( $arr ); $i < $n; $i++ ) {
			$k = stripslashes($arr[$i]->$key);
			$t = stripslashes($arr[$i]->$text);
			if ( isset($arr[$i]->id) ) {
				$id = $arr[$i]->id;
			} else {
				$id = str_replace( array( '[', ']'), array( '_', '_' ), $tag_name ) . $i;
			}
			$extra = " id=\"" . $id . "\"";

			if (is_array( $selected )) {
				foreach ($selected as $obj) {
					$k2 = stripslashes($obj->$key);
					if ($k == $k2) {
						$extra .= " checked=\"checked\"";
						break;
					}
				}
			} else {
				$extra .= ($k == stripslashes($selected) ? "  checked=\"checked\"" : '');
			}
			if ( $required && ( $i == 0 ) ) {
				$isReq="mosReq=\"".$required."\"";
			} else {
				$isReq="";
			}
			$html[] = "<input type=\"radio\" name=\"$tag_name\" $isReq $tag_attribs value=\"" . $k . "\"$extra /> <label for=\"" . $id . "\">" . hwdvsgetlangdefinition($t) . "</label>";
		}
		return $html;
	}
	function radioList( $arr, $tag_name, $tag_attribs, $key, $text, $selected, $required=0 ) {
		return "\n\t".implode("\n\t ", moshwdvsHTML::radioListArr( $arr, $tag_name, $tag_attribs, $key, $text, $selected, $required ))."\n";
	}
	function radioListTable( $arr, $tag_name, $tag_attribs, $key, $text, $selected, $cols=0, $rows=1, $size=0, $required=0 ) {
		$cellsHtml = moshwdvsHTML::radioListArr( $arr, $tag_name, $tag_attribs, $key, $text, $selected, $required );
		return moshwdvsHTML::list2Table( $cellsHtml, $cols, $rows, $size );
	}
	function selectList( $arr, $tag_name, $tag_attribs, $key, $text, $selected, $required=0 ) {
		reset( $arr );
		$html = "\n<select name=\"$tag_name\" $tag_attribs>";
		if(!$required) $html .= "\n\t<option value=\"\"> </option>";

		for ($i=0, $n=count( $arr ); $i < $n; $i++ ) {
			$k = stripslashes($arr[$i]->$key);
			$t = stripslashes($arr[$i]->$text);
			$id = isset($arr[$i]->id) ? $arr[$i]->id : null;

			$extra = '';
			$extra .= $id ? " id=\"" . $arr[$i]->id . "\"" : '';
			if (is_array( $selected )) {
				foreach ($selected as $obj) {
					if ( is_object( $obj ) ) {
						$k2		=	$obj->$key;
					} else {
						$k2		=	$obj;
					}
					if ($k == $k2) {
						$extra	.=	" selected=\"selected\"";
						break;
					}
				}
			} else {
				$extra .= ($k == stripslashes($selected) ? " selected=\"selected\"" : '');
			}
			$html .= "\n\t<option value=\"".$k."\"$extra>";
			$html .= hwdvsgetlangdefinition($t);
			$html .= "</option>";
		}
		$html .= "\n</select>\n";
		return $html;
	}
	function checkboxListArr( $arr, $tag_name, $tag_attribs,  $key='value', $text='text',$selected=null, $required=0  ) {
		reset( $arr );
		$html = array();
		for ($i=0, $n=count( $arr ); $i < $n; $i++ ) {
			$k = $arr[$i]->$key;
			$t = $arr[$i]->$text;
			if ( isset($arr[$i]->id) ) {
				$id = $arr[$i]->id;
			} else {
				$id = str_replace( array( '[', ']'), array( '_', '_' ), $tag_name ) . $i;
			}
			$extra = " id=\"" . $id . "\"";

			if (is_array( $selected )) {
				foreach ($selected as $obj) {
					if ( is_object( $obj ) ) {
						$k2		=	$obj->$key;
					} else {
						$k2		=	$obj;
					}
					if ($k == $k2) {
						$extra	.=	" checked=\"checked\"";
						break;
					}
				}
			} else {
				$extra .= ($k == $selected ? " checked=\"checked\"" : '');
			}
			if ( $required && ( $i == 0 ) ) {
				$isReq="mosReq=\"".$required."\"";
			} else {
				$isReq="";
			}
			$html[] = "<input type=\"checkbox\" name=\"$tag_name\" $isReq value=\"".$k."\"$extra $tag_attribs /> <label for=\"" . $id . "\">" . hwdvsgetlangdefinition($t) . "</label>";
		}
		return $html;
	}
	function checkboxList( $arr, $tag_name, $tag_attribs,  $key='value', $text='text',$selected=null, $required=0 ) {
		return "\n\t".implode("\n\t", moshwdvsHTML::checkboxListArr( $arr, $tag_name, $tag_attribs,  $key, $text,$selected, $required ))."\n";
	}
	function checkboxListTable( $arr, $tag_name, $tag_attribs,  $key='value', $text='text',$selected=null, $cols=0, $rows=0, $size=0, $required=0 ) {
		$cellsHtml = moshwdvsHTML::checkboxListArr( $arr, $tag_name, $tag_attribs,  $key, $text,$selected, $required );
		return moshwdvsHTML::list2Table( $cellsHtml, $cols, $rows, $size );
	}
	// private methods:
	function list2Table ( $cellsHtml, $cols, $rows, $size ) {
		$cells = count($cellsHtml);
		if ($size == 0) {
			$localstyle = ""; //" style='width:100%'";
		} else {
			$size = (($size-($size % 3)) / 3  ) * 2; // int div  3 * 2 width/heigh ratio
			$localstyle = " style='width:".$size."em;'";
		}
		$return="";
		if ($cells) {
			if ($rows) {
				$return = "\n\t<table class='cbMulti'".$localstyle.">";
				$cols = ($cells-($cells % $rows)) / $rows;	// int div
				if ($cells % $rows) $cols++;
				$lineIdx=0;
				for ($lineIdx=0 ; $lineIdx < min($rows, $cells) ; $lineIdx++) {
					$return .= "\n\t\t<tr>";
					for ($i=$lineIdx ; $i < $cells; $i += $rows) {
						$return .= "<td>".$cellsHtml[$i]."</td>";
					}
					$return .= "</tr>\n";
				}
				$return .= "\t</table>\n";
			} else if ($cols) {
				$return = "\n\t<table class='cbMulti'".$localstyle.">";
				$idx=0;
				while ($cells) {
					$return .= "\n\t\t<tr>";
					for ($i=0, $n=min($cells,$cols); $i < $n; $i++, $cells-- ) {
						$return .= "<td>".$cellsHtml[$idx++]."</td>";
					}
					$return .= "</tr>\n";
				}
				$return .= "\t</table>\n";
			} else {
				$return = "\n\t".implode("\n\t ", $cellsHtml)."\n";
			}
		}
		return $return;
	}
} // end class moshwdvsHTML





?>