<?php
/**
 *    @version 2.1.1 Build 21106 Alpha [ Drury ]
 *    @package hwdVideoShare
 *    @copyright (C) 2007 - 2009 Highwood Design
 *    @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 ***
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );
/**
 * @package    hwdVideoShare
 * @author     Dave Horsfall <info@highwooddesign.co.uk>
 * @copyright  2008 Highwood Design
 * @license    http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @version    1.1.4 Alpha RC3.5
 */
class hwd_vs_videoplayer {
    /**
     * Prepares the code to insert the third party video
     *
     * @param string $option  the $video_id output containing video paramters
     * @param int    $flv_width  the video width
     * @param int    $flv_height  the video height
     * @return       $code   the third party embed code
     */
    function prepareplayer($flv_url, $flv_width=427, $flv_height=340, $ui=0, $mediatype="video", $flv_path=null, $thumb_url=null)
	{
		global $task, $smarty, $option, $show_longtail, $longtail_channel, $mainframe;
		if (!defined('HWDVIDSPATH')) { define('HWDVIDSPATH', dirname(__FILE__).'/../../'); }
		$c = hwd_vs_Config::get_instance();
		$code=null;

		$params = $this->getMyParams( $option, $task, 4);

	    if (isset($flv_width) && !empty($flv_width)) {
	    	$param_width = $flv_width;
	    } else {
	    	$param_width = $params->get('width', '427');
		}
	    if (isset($flv_height) && !empty($flv_height)) {
	    	$param_height = $flv_height;
	    } else {
	    	$param_height = $params->get('height', '340');
		}

	    $param_bgcolor = $params->get('bgcolor', '333333');
	    $param_fgcolor = $params->get('fgcolor', 'cccccc');
	    $param_lightcolor = $params->get('lightcolor', 'ffffff');
	    $param_screencolor = $params->get('screencolor', 'ffffff');
	    $param_link = $params->get('link', null);
	    $param_start = $params->get('start', null);
	    $param_controlbar = $params->get('controlbar', 'bottom');
	    $param_logo = $params->get('logo', null);
	    $param_skin = $params->get('skin', null);
	    $param_autostart = $params->get('autostart', null);
	    $param_bufferlength = $params->get('bufferlength', '5');
	    $param_displayclick = $params->get('displayclick', 'play');
	    $param_fullscreen = $params->get('fullscreen', 'true');
	    $param_mute = $params->get('mute', 'false');
	    $param_quality = $params->get('quality', 'true');
	    $param_repeat = $params->get('repeat', 'false');
	    $param_stretching = $params->get('stretching', 'uniform');
	    $param_volume = $params->get('volume', '60');

		$flashvars = "&file=".$flv_url;
		if (isset($param_link) && !empty($param_link)) {
		  $flashvars.= "&link=".$param_link;
		}
		if (isset($param_start) && !empty($param_start)) {
		  $flashvars.= "&start=".$param_start;
		}
		if (isset($param_logo) && !empty($param_logo)) {
		  $flashvars.= "&logo=".$param_logo;
		}
		if (isset($param_skin) && !empty($param_skin)) {
		  $flashvars.= "&skin=".$param_skin;
		}
		if (isset($param_bufferlength) && !empty($param_bufferlength)) {
		  $flashvars.= "&bufferlength=".$param_bufferlength;
		}
		if (isset($param_volume) && !empty($param_volume)) {
		  $flashvars.= "&volume=".$param_volume;
		}
		if ($param_controlbar == 1) {
		  $flashvars.= "&controlbar=over";
		} else if ($param_controlbar == 2) {
		  $flashvars.= "&controlbar=none";
		}
		if ($param_autostart == 1 || $mediatype == "playlist") {
		  $flashvars.= "&autostart=true";
		}
		if ($param_displayclick == 1) {
		  $flashvars.= "&displayclick=link";
		} else if ($param_displayclick == 2) {
		  $flashvars.= "&displayclick=fullscreen";
		} else if ($param_displayclick == 3) {
		  $flashvars.= "&displayclick=mute";
		} else if ($param_displayclick == 4) {
		  $flashvars.= "&displayclick=next";
		} else if ($param_displayclick == 5) {
		  $flashvars.= "&displayclick=none";
		}
		if ($param_fullscreen == 0) {
		  $flashvars.= "&fullscreen=false";
		}
		if ($param_mute == 1) {
		  $flashvars.= "&mute=true";
		}
		if ($param_quality == 0) {
		  $flashvars.= "&quality=high";
		}
		if ($mediatype == "playlist") {
		  $flashvars.= "&repeat=list";
		} else if ($param_repeat == 1) {
		  $flashvars.= "&repeat=true";
		}
		if ($param_stretching == 1) {
		  $flashvars.= "&stretching=fill";
		} else if ($param_stretching == 2) {
		  $flashvars.= "&stretching=exactfit";
		} else if ($param_stretching == 3) {
		  $flashvars.= "&stretching=none";
		}
		$flashvars.= "&backcolor=".$param_bgcolor;
		$flashvars.= "&frontcolor=".$param_fgcolor;
		$flashvars.= "&lightcolor=".$param_lightcolor;
		$flashvars.= "&screencolor=".$param_screencolor;
		if ($mediatype == "remote" || $mediatype == "video") {
			$flashvars.= "&type=video";
		}
		//if (($mediatype !== "playlist") && !empty($thumb_url) && @fclose(@fopen($thumb_url, "r"))) {
		if (($mediatype !== "playlist") && !empty($thumb_url)) {
			$flashvars.= "&image=".$thumb_url;
		}

		$smarty->assign("player_width", $param_width);

		if (!defined( '_HWD_VS_SWFOFLAG' )) {
			define( '_HWD_VS_SWFOFLAG', 1 );
			if ($option == "com_hwdvideoshare") {
				$mainframe->addCustomHeadTag('<script type="text/javascript" src="'.JURI::root( true ).'/components/com_hwdvideoshare/js/swfobject.js"></script>');
				if (($c->loadmootools == "on") && (strpos(JURI::base(true), "/administrator") === false)) {
					$mainframe->addCustomHeadTag('<script type="text/javascript" src="'.JURI::root( true ).'/components/com_hwdvideoshare/js/mootools-1.2-core-yc.js"></script>');
				}
			} else {
				$code.='<script type="text/javascript" src="'.JURI::root( true ).'/components/com_hwdvideoshare/js/swfobject.js"></script>';
				if ($c->loadmootools == "on") {
					$code.='<script type="text/javascript" src="'.JURI::root( true ).'/components/com_hwdvideoshare/js/mootools-1.2-core-yc.js"></script>';
				}
			}

		}
		if ($show_longtail) {
			$divid="mediaspace";
		} else {
			$divid="flashcontent_".$ui;
		}

			$code.="<div id=\"".$divid."\" style=\"text-align:inherit;height:100%;width:100%;\">"._HWDVIDS_INFO_ENABLEJAVA."</div>
					<script type=\"text/javascript\">
					window.addEvent('domready', function(){
										   var so_".$ui." = new SWFObject(\"".JURI::root()."components/com_hwdvideoshare/core/videoplayer/jwflv/mediaplayer.swf?".rand()."\", \"hwdvideo_".$ui."\", \"".$param_width."\", \"".$param_height."\", \"8\", \"#".$param_bgcolor."\");
										   so_".$ui.".addVariable(\"width\",\"".$param_width."\");
										   so_".$ui.".addVariable(\"height\",\"".$param_height."\");";
			if ($show_longtail) {
				$code.="                   so_".$ui.".addVariable(\"channel\", \"".$longtail_channel."\");
                                           so_".$ui.".addVariable(\"plugins\", \"ltas\");";
			}
			$code.="					   so_".$ui.".addParam(\"allowfullscreen\", \"true\");
										   so_".$ui.".addParam(\"allowscriptaccess\", \"always\");
										   so_".$ui.".addParam(\"type\",\"video\");
										   so_".$ui.".addParam(\"quality\", \"high\");
										   so_".$ui.".addParam(\"wmode\", \"transparent\");
										   so_".$ui.".addParam(\"flashvars\",\"".$flashvars."\");
										   so_".$ui.".write(\"".$divid."\");
					});
					</script>";
		if ($show_longtail) {
			$code.='<script language="JavaScript" src="http://www.ltassrv.com/serve/api5.4.asp?d=5650&s=6528&c=5774&v=1"></script>';
		}
		return $code;
	}
    function prepareEmbeddedPlayer($flv_url, $flv_width=427, $flv_height=340, $mediatype=null, $thumb_url=null)
	{
		global $task, $smarty, $option, $show_longtail, $longtail_channel, $mainframe;
		if (!defined('HWDVIDSPATH')) { define('HWDVIDSPATH', dirname(__FILE__).'/../../'); }
		$c = hwd_vs_Config::get_instance();
		$code=null;

		$params = $this->getMyParams( $option, $task, 4);

	    if (isset($flv_width) && !empty($flv_width)) {
	    	$param_width = $flv_width;
	    } else {
	    	$param_width = $params->get('width', '427');
		}
	    if (isset($flv_height) && !empty($flv_height)) {
	    	$param_height = $flv_height;
	    } else {
	    	$param_height = $params->get('height', '340');
		}

	    $param_bgcolor = $params->get('bgcolor', '333333');
	    $param_fgcolor = $params->get('fgcolor', 'cccccc');
	    $param_lightcolor = $params->get('lightcolor', 'ffffff');
	    $param_screencolor = $params->get('screencolor', 'ffffff');
	    $param_link = $params->get('link', null);
	    $param_start = $params->get('start', null);
	    $param_controlbar = $params->get('controlbar', 'bottom');
	    $param_logo = $params->get('logo', null);
	    $param_skin = $params->get('skin', null);
	    $param_autostart = $params->get('autostart', null);
	    $param_bufferlength = $params->get('bufferlength', '5');
	    $param_displayclick = $params->get('displayclick', 'play');
	    $param_fullscreen = $params->get('fullscreen', 'true');
	    $param_mute = $params->get('mute', 'false');
	    $param_quality = $params->get('quality', 'true');
	    $param_repeat = $params->get('repeat', 'false');
	    $param_stretching = $params->get('stretching', 'uniform');
	    $param_volume = $params->get('volume', '60');

		$flashvars = "&file=".$flv_url;
		if (isset($param_link) && !empty($param_link)) {
		  $flashvars.= "&link=".$param_link;
		}
		if (isset($param_start) && !empty($param_start)) {
		  $flashvars.= "&start=".$param_start;
		}
		if (isset($param_logo) && !empty($param_logo)) {
		  $flashvars.= "&logo=".$param_logo;
		}
		if (isset($param_skin) && !empty($param_skin)) {
		  $flashvars.= "&skin=".$param_skin;
		}
		if (isset($param_bufferlength) && !empty($param_bufferlength)) {
		  $flashvars.= "&bufferlength=".$param_bufferlength;
		}
		if (isset($param_volume) && !empty($param_volume)) {
		  $flashvars.= "&volume=".$param_volume;
		}
		if ($param_controlbar == 1) {
		  $flashvars.= "&controlbar=over";
		} else if ($param_controlbar == 2) {
		  $flashvars.= "&controlbar=none";
		}
		if ($param_autostart == 1 || $mediatype == "playlist") {
		  $flashvars.= "&autostart=true";
		}
		if ($param_displayclick == 1) {
		  $flashvars.= "&displayclick=link";
		} else if ($param_displayclick == 2) {
		  $flashvars.= "&displayclick=fullscreen";
		} else if ($param_displayclick == 3) {
		  $flashvars.= "&displayclick=mute";
		} else if ($param_displayclick == 4) {
		  $flashvars.= "&displayclick=next";
		} else if ($param_displayclick == 5) {
		  $flashvars.= "&displayclick=none";
		}
		if ($param_fullscreen == 0) {
		  $flashvars.= "&fullscreen=false";
		}
		if ($param_mute == 1) {
		  $flashvars.= "&mute=true";
		}
		if ($param_quality == 0) {
		  $flashvars.= "&quality=high";
		}
		if ($mediatype == "playlist") {
		  $flashvars.= "&repeat=list";
		} else if ($param_repeat == 1) {
		  $flashvars.= "&repeat=true";
		}
		if ($param_stretching == 1) {
		  $flashvars.= "&stretching=fill";
		} else if ($param_stretching == 2) {
		  $flashvars.= "&stretching=exactfit";
		} else if ($param_stretching == 3) {
		  $flashvars.= "&stretching=none";
		}
		$flashvars.= "&backcolor=".$param_bgcolor;
		$flashvars.= "&frontcolor=".$param_fgcolor;
		$flashvars.= "&lightcolor=".$param_lightcolor;
		$flashvars.= "&screencolor=".$param_screencolor;
		//$flashvars.= "&width=".$param_width;
		//$flashvars.= "&height=".$param_height;
		if ($mediatype == "remote" || $mediatype == "video") {
			$flashvars.= "&type=video";
		}
		//if (($mediatype !== "playlist") && !empty($thumb_url) && @fclose(@fopen($thumb_url, "r"))) {
		if (($mediatype !== "playlist") && !empty($thumb_url)) {
			$flashvars.= "&image=".$thumb_url;
		}

		$smarty->assign("player_width", $param_width);

		if ($show_longtail) {
			$code.='<div name="mediaspace" id="mediaspace">';
		}
		$code.='<embed src="'.JURI::root().'components/com_hwdvideoshare/core/videoplayer/jwflv/mediaplayer.swf" width="'.$param_width.'" height="'.$param_height.'" allowscriptaccess="always" wmode="transparent" allowfullscreen="true" flashvars="'.$flashvars.'" />';
		if ($show_longtail) {
			$code.='</div>';
			$code.='<script language="JavaScript" src="http://www.ltassrv.com/serve/api5.4.asp?d=5650&s=6528&c=5774&v=1"></script>';
		}
		return $code;
	}
    function prepareEmbedCode($flv_url, $flv_width=427, $flv_height=340, $mediatype=null, $thumb_url=null)
	{
		global $task, $mosConfig_sitename, $option, $mainframe;
		if (!defined('HWDVIDSPATH')) { define('HWDVIDSPATH', dirname(__FILE__).'/../../'); }
		$c = hwd_vs_Config::get_instance();
		$code=null;

		$params = $this->getMyParams( $option, $task, 4);

	    if (isset($flv_width) && !empty($flv_width)) {
	    	$param_width = $flv_width;
	    } else {
	    	$param_width = $params->get('width', '427');
		}
	    if (isset($flv_height) && !empty($flv_height)) {
	    	$param_height = $flv_height;
	    } else {
	    	$param_height = $params->get('height', '340');
		}

	    $param_bgcolor = $params->get('bgcolor', '333333');
	    $param_fgcolor = $params->get('fgcolor', 'cccccc');
	    $param_lightcolor = $params->get('lightcolor', 'ffffff');
	    $param_screencolor = $params->get('screencolor', 'ffffff');
	    $param_link = $params->get('link', null);
	    $param_start = $params->get('start', null);
	    $param_controlbar = $params->get('controlbar', 'bottom');
	    $param_logo = $params->get('logo', null);
	    $param_skin = $params->get('skin', null);
	    $param_autostart = $params->get('autostart', null);
	    $param_bufferlength = $params->get('bufferlength', '5');
	    $param_displayclick = $params->get('displayclick', 'play');
	    $param_fullscreen = $params->get('fullscreen', 'true');
	    $param_mute = $params->get('mute', 'false');
	    $param_quality = $params->get('quality', 'true');
	    $param_repeat = $params->get('repeat', 'false');
	    $param_stretching = $params->get('stretching', 'uniform');
	    $param_volume = $params->get('volume', '60');

		$flashvars = "&file=".$flv_url;
		if (isset($param_link) && !empty($param_link)) {
		  $flashvars.= "&link=".$param_link;
		}
		if (isset($param_start) && !empty($param_start)) {
		  $flashvars.= "&start=".$param_start;
		}
		if (isset($param_logo) && !empty($param_logo)) {
		  $flashvars.= "&logo=".$param_logo;
		}
		if (isset($param_skin) && !empty($param_skin)) {
		  $flashvars.= "&skin=".$param_skin;
		}
		if (isset($param_bufferlength) && !empty($param_bufferlength)) {
		  $flashvars.= "&bufferlength=".$param_bufferlength;
		}
		if (isset($param_volume) && !empty($param_volume)) {
		  $flashvars.= "&volume=".$param_volume;
		}
		if ($param_controlbar == 1) {
		  $flashvars.= "&controlbar=over";
		} else if ($param_controlbar == 2) {
		  $flashvars.= "&controlbar=none";
		}
		if ($param_autostart == 1 || $mediatype == "playlist") {
		  $flashvars.= "&autostart=true";
		}
		if ($param_displayclick == 1) {
		  $flashvars.= "&displayclick=link";
		} else if ($param_displayclick == 2) {
		  $flashvars.= "&displayclick=fullscreen";
		} else if ($param_displayclick == 3) {
		  $flashvars.= "&displayclick=mute";
		} else if ($param_displayclick == 4) {
		  $flashvars.= "&displayclick=next";
		} else if ($param_displayclick == 5) {
		  $flashvars.= "&displayclick=none";
		}
		if ($param_fullscreen == 0) {
		  $flashvars.= "&fullscreen=false";
		}
		if ($param_mute == 1) {
		  $flashvars.= "&mute=true";
		}
		if ($param_quality == 0) {
		  $flashvars.= "&quality=high";
		}
		if ($mediatype == "playlist") {
		  $flashvars.= "&repeat=list";
		} else if ($param_repeat == 1) {
		  $flashvars.= "&repeat=true";
		}
		if ($param_stretching == 1) {
		  $flashvars.= "&stretching=fill";
		} else if ($param_stretching == 2) {
		  $flashvars.= "&stretching=exactfit";
		} else if ($param_stretching == 3) {
		  $flashvars.= "&stretching=none";
		}
		$flashvars.= "&backcolor=".$param_bgcolor;
		$flashvars.= "&frontcolor=".$param_fgcolor;
		$flashvars.= "&lightcolor=".$param_lightcolor;
		$flashvars.= "&screencolor=".$param_screencolor;
		if ($mediatype == "remote" || $mediatype == "video") {
			$flashvars.= "&type=video";
		}
		if (($mediatype !== "playlist") && !empty($thumb_url) && @fclose(@fopen($thumb_url, "r"))) {
			$flashvars.= "&image=".$thumb_url;
		}

		if ($c->embedreturnlink == 1) {
			$code.='<div><center>';
		}
		$code.='<embed src=&#34;'.JURI::root().'components/com_hwdvideoshare/core/videoplayer/jwflv/mediaplayer.swf&#34; width=&#34;'.$param_width.'&#34; height=&#34;'.$param_height.'&#34; allowscriptaccess=&#34;always&#34; allowfullscreen=&#34;true&#34; flashvars=&#34;'.$flashvars.'&#34; />';
		if ($c->embedreturnlink == 1) {
			$code.='<br /><a href=&#34;'.JURI::root().'&#34; title=&#34;'.$GLOBALS['mosConfig_sitename'].'&#34;>'.$GLOBALS['mosConfig_sitename'].'</a></center></div>';
		}
		return $code;
	}
	/**
	* Compiles information to add or edit a plugin
	* @param string The current GET/POST option
	* @param integer The unique id of the record to edit
	*/
	function getMyParams( $option, $task, $uid) {
		global $database, $my, $mainframe, $mosConfig_absolute_path, $_HWD_VS_PLUGINS, $_POST;
		$db = & JFactory::getDBO();

		require_once(HWDVIDSPATH.'/../../administrator/components/com_hwdvideoshare/source/controllers/plugins.php');
		require_once(HWDVIDSPATH.'/../../administrator/components/com_hwdvideoshare/plugin.class.php');
		include_once(HWDVIDSPATH."/../../administrator/components/com_hwdvideoshare/library/cb/cb.params.php");

		$action	= null;
		$element = null;

		$row 	= new hwdvidsplugin($db);
		if ( $uid ) {
			// load the row from the db table
			$row->load( (int) $uid );
		}

		$params =& new cbParamsEditorController( $row->params, $element, $element, $row );
		return $params;

	}
}
?>