<?php
/**
 *    @version 2.1.1 Build 21106 Alpha [ Drury ]
 *    @package hwdVideoShare
 *    @copyright (C) 2007 - 2009 Highwood Design
 *    @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 ***
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

/**
 * This class is the HTML generator for hwdVideoShare frontend
 *
 * @package    hwdVideoShare
 * @author     Dave Horsfall <info@highwooddesign.co.uk>
 * @copyright  2008 Highwood Design
 * @license    http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @version    1.1.4 Alpha RC2.13
 */
class hwd_vs_html
{
    /**
     * Outputs frontpage HTML
     *
     * @param string $option  the joomla component name
     * @param array  $rows  array of video data
     * @param array  $rowsfeatured  array of featured video data
     * @param object $pageNav  page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
    function frontpage($option, $rows, $rowsfeatured, $pageNav, $total, $rowsnow, $mostviewed, $mostfavoured, $mostpopular)
    {
		global $Itemid, $smarty, $mainframe;
		$c = hwd_vs_Config::get_instance();
  		$db =& JFactory::getDBO();
		// load the menu name
		jimport( 'joomla.application.menu' );
		$menu   = &JMenu::getInstance('site');
		$active = &$menu->getActive();
		if (!empty($active->name)) {$metatitle = $active->name;} else {$metatitle = _HWDVIDS_META_DEFAULT;}
		// set the page/meta title
		$mainframe->setPageTitle( $metatitle );
		$mainframe->addMetaTag( 'title' , $metatitle );
		hwd_vs_tools::generateActiveLink(1);
		// define javascript
		hwd_vs_javascript::confirmdelete();
		$js = hwd_vs_javascript::loadTabber(); echo $js;

		$k = 0;
		if (count($rowsfeatured) > 0) {
			$smarty->assign("print_featured", 1);
			if ($c->fvid_w == 0) { $c->fvid_w = "100%"; }
			$featured_video_player = hwd_vs_tools::generateVideoPlayer($rowsfeatured[0], $c->fvid_w, $c->fvid_h);
			$smarty->assign("featured_video_player", $featured_video_player);

			$featuredlist = hwd_vs_tools::generateVideoListFromSql($rowsfeatured, "featuredthumbs");
			$smarty->assign("featuredlist", $featuredlist);
		}
		if (count($rowsfeatured) > 1) {
			$smarty->assign("print_multiple_featured", 1);
		}

		if (count($rows) > 0) {
			$smarty->assign("print_videolist", 1);
			$list = hwd_vs_tools::generateVideoListFromSql($rows);
			$smarty->assign("list", $list);
		}

		if (count($rowsnow) > 0 && $c->frontpage_watched == "1") {
			$hwdvids_params = array();
			$hwdvids_params['novtd'] = $c->bwn_no;
			$smarty->assign("print_nowlist", 1);
			$nowlist = hwd_vs_tools::generateVideoListFromSql($rowsnow);
			$bw_carousel_js = hwd_vs_tools::generateCarousel( $nowlist, "bwn", $hwdvids_params, "fmtItem_bwn");
			$smarty->assign("bw_carousel_js", $bw_carousel_js);
		}

		if (count($mostviewed) > 0 && $c->frontpage_viewed !== "0") {
			$smarty->assign("print_mostviewed", 1);
			$mostviewedlist = hwd_vs_tools::generateVideoListFromXml($mostviewed);
			$smarty->assign("mostviewedlist", $mostviewedlist);
			if ($c->frontpage_viewed == "today") {
				$smarty->assign("title_mostviewed", _HWDVIDS_MVTD);
			} else if ($c->frontpage_viewed == "thisweek") {
				$smarty->assign("title_mostviewed", _HWDVIDS_MVTW);
			} else if ($c->frontpage_viewed == "thismonth") {
				$smarty->assign("title_mostviewed", _HWDVIDS_MVTM);
			} else if ($c->frontpage_viewed == "alltime") {
				$smarty->assign("title_mostviewed", _HWDVIDS_MVAT);
			}
		}

		if (count($mostfavoured) > 0 && $c->frontpage_favoured !== "0") {
			$smarty->assign("print_mostfavoured", 1);
			$mostfavouredlist = hwd_vs_tools::generateVideoListFromXml($mostfavoured);
			$smarty->assign("mostfavouredlist", $mostfavouredlist);
			if ($c->frontpage_favoured == "today") {
				$smarty->assign("title_mostfavoured", _HWDVIDS_MFTD);
			} else if ($c->frontpage_favoured == "thisweek") {
				$smarty->assign("title_mostfavoured", _HWDVIDS_MFTW);
			} else if ($c->frontpage_favoured == "thismonth") {
				$smarty->assign("title_mostfavoured", _HWDVIDS_MFTM);
			} else if ($c->frontpage_favoured == "alltime") {
				$smarty->assign("title_mostfavoured", _HWDVIDS_MFAT);
			}
		}

		if (count($mostpopular) > 0 && $c->frontpage_popular !== "0") {
			$smarty->assign("print_mostpopular", 1);
			$mostpopularlist = hwd_vs_tools::generateVideoListFromXml($mostpopular);
			$smarty->assign("mostpopularlist", $mostpopularlist);
			if ($c->frontpage_popular == "today") {
				$smarty->assign("title_mostpopular", _HWDVIDS_MPTD);
			} else if ($c->frontpage_popular == "thisweek") {
				$smarty->assign("title_mostpopular", _HWDVIDS_MPTW);
			} else if ($c->frontpage_popular == "thismonth") {
				$smarty->assign("title_mostpopular", _HWDVIDS_MPTM);
			} else if ($c->frontpage_popular == "alltime") {
				$smarty->assign("title_mostpopular", _HWDVIDS_MPAT);
			}
		}

		$smarty->assign( "featured_link" , JRoute::_("index.php?option=com_hwdvideoshare&Itemid=".$Itemid."&task=featuredvids") );

		$page = $total - $c->vpp;
		$pageNavigation = null;
		if ( $page > 0 ) {
			$link = "index.php?option=com_hwdvideoshare&Itemid=".$Itemid;
			$pageNavigation.= "<div class=\"pagenavi\" align=\"center\">";
			$pageNavigation.= $pageNav->writePagesLinks($link);
			$pageNavigation.= "<div class=\"pagecount\">".$pageNav->writePagesCounter()."</div>";
			$pageNavigation.= "</div>";
		}
		$smarty->assign("pageNavigation", $pageNavigation);

		$smarty->display('index.tpl');
		return;
    }
    /**
     * Outputs results from user search
     *
     * @param string $option  the joomla component name
     * @param int    $totalvids  the total matching video count
     * @param array  $matchingvids  array of matching video data
     * @param object $videoNav  page navigation object
     * @param int    $totalgroups  the total matching group count
     * @param array  $matchinggroups  array of matching group data
     * @param object $groupNav  page navigation object
     * @param string $searchterm  the search pattern from user search
     * @return       Nothing
     */
    function search($option, $totalvids, $matchingvids, $videoNav, $totalgroups, $matchinggroups, $groupNav, $searchterm)
    {
		global $Itemid, $mainframe, $smarty;
		$c = hwd_vs_Config::get_instance();
		// load the menu name
		jimport( 'joomla.application.menu' );
		$menu   = &JMenu::getInstance('site');
		$active = &$menu->getActive();
		if (!empty($active->name)) {$metatitle = $active->name;} else {$metatitle = _HWDVIDS_META_DEFAULT;}
		// set the page/meta title
		$mainframe->setPageTitle( $metatitle." - "._HWDVIDS_META_SR." - ".$searchterm );
		$mainframe->addMetaTag( 'title' , $metatitle." - "._HWDVIDS_META_SR." - ".$searchterm );
		hwd_vs_tools::generateActiveLink(1);

			$smarty->assign("searchterm", $searchterm);

		if (count($matchingvids) > 0) {
			$smarty->assign("print_matchvids", 1);
			$matchingvids = hwd_vs_tools::generateVideoListFromSql($matchingvids);
			$smarty->assign("matchingvids", $matchingvids);

			$vpage = $totalvids - $c->vpp;
			$vpageNavigation = null;
			if ( $vpage > 0 ) {
			$vlink = "index.php?option=com_hwdvideoshare&task=search&searchterm=".$searchterm."&Itemid=".$Itemid;
			$vpageNavigation.= "<div class=\"pagenavi\" align=\"center\">";
			$vpageNavigation.= $videoNav->writePagesLinks($vlink);
			$vpageNavigation.= "<div class=\"pagecount\">".$videoNav->writePagesCounter()."</div>";
			$vpageNavigation.= "</div>";
			}
			$smarty->assign("vpageNavigation", $vpageNavigation);


		} else {
			$smarty->assign("mvempty", _HWDVIDS_INFO_NMV);
		}

		if (count($matchinggroups) > 0) {
			$smarty->assign("print_matchgrps", 1);
			$matchinggroups = hwd_vs_tools::generateGroupListFromSql($matchinggroups);
			$smarty->assign("matchinggroups", $matchinggroups);

			$gpage = $totalgroups - $c->gpp;
			$gpageNavigation = null;
			if ( $gpage > 0 ) {
			$glink = "index.php?option=com_hwdvideoshare&task=search&searchterm=".$searchterm."&Itemid=".$Itemid;
			$gpageNavigation.= "<div class=\"pagenavi\" align=\"center\">";
			$gpageNavigation.= $groupNav->writePagesLinks($glink);
			$gpageNavigation.= "<div class=\"pagecount\">".$groupNav->writePagesCounter()."</div>";
			$gpageNavigation.= "</div>";
			}
			$smarty->assign("gpageNavigation", $gpageNavigation);


		} else {
			$smarty->assign("mgempty", _HWDVIDS_INFO_NMG);
		}

		$smarty->display('search.tpl');
		return;
    }
    /**
     * Constructs the necessary upload form
     *
     * @param string $option  the joomla component name
     * @param int    $uploadpage  the parameter that determines the necessary upload page
     * @param string $videotype  determines the source of video file
     * @param int    $checksecurity  an integer for checking captcha security
     * @param string $title  user inputted video data
     * @param string $description  user inputted video data
     * @param int    $category_id  user inputted video data
     * @param string $tags  user inputted video data
     * @param string $public_private  user inputted video data
     * @param int    $allow_comments  user inputted video data
     * @param int    $allow_embedding  user inputted video data
     * @param int    $allow_ratings  user inputted video data
     * @return       Nothing
     */
    function uploadMedia($option, $uploadpage, $videotype, $checksecurity, $title, $description, $category_id, $tags, $public_private, $allow_comments, $allow_embedding, $allow_ratings)
    {
		global $mainframe, $Itemid, $my, $params, $smarty;
		$c = hwd_vs_Config::get_instance();

		// load the menu name
		jimport( 'joomla.application.menu' );
		$menu   = &JMenu::getInstance('site');
		$active = &$menu->getActive();
		if (!empty($active->name)) {$metatitle = $active->name;} else {$metatitle = _HWDVIDS_META_DEFAULT;}
		// set the page/meta title
		$mainframe->setPageTitle( $metatitle." - "._HWDVIDS_META_UPLD );
		$mainframe->addMetaTag( 'title' , $metatitle." - "._HWDVIDS_META_UPLD );
		hwd_vs_tools::generateActiveLink(4);

		$supported_websites = hwd_vs_tools::generateSupportedWebsiteList();
		$smarty->assign("supported_websites", $supported_websites);


		if ($uploadpage == "2") {
			$allowedformats = hwd_vs_tools::generateAllowedFormats();
			$smarty->assign("allowed_formats", $allowedformats);
			$smarty->assign("maximum_upload", $c->maxupld);

			if ($c->locupldmeth == "3") {
				require_once(HWDVIDSPATH."/mvc/view/upload_perl.php");
				$smarty->display('upload_local_perl.tpl');
				return;
			} else if ($c->locupldmeth == "2") {
				require_once(HWDVIDSPATH."/mvc/view/upload_flash.php");
				$smarty->display('upload_local_flash.tpl');
				return;
			} else if ($c->locupldmeth == "1") {
				// option removed
			} else if ($c->locupldmeth == "0") {
				require_once(HWDVIDSPATH."/mvc/view/upload_php.php");
				$smarty->display('upload_local_php.tpl');
				return;
			} else {
				require_once(HWDVIDSPATH."/mvc/view/upload_php.php");
				$smarty->display('upload_local_php.tpl');
				return;
			}
		} else if ($uploadpage == "thirdparty") {
			hwd_vs_javascript::checkaddform();


				$smarty->display('upload_thirdparty.tpl');
				return;




		} else if ($uploadpage == "1") {
			hwd_vs_javascript::checkuploadform();
		$captcha = hwd_vs_tools::generateCaptcha();
		$smarty->assign("captcha", $captcha);






				$smarty->display('upload_local.tpl');
				return;
		} else if ($uploadpage == "0") {
			hwd_vs_javascript::disablesubmit();
				$smarty->display('upload_choice.tpl');
				return;

		}
    }
    /**
     * Confirms local file upload
     *
     * @param string $option  the joomla component name
     * @param string $uploadname  the title of uploaded media
     * @return       Nothing
     */
    function uploadConfirm($option, $uploadname)
    {
		global $Itemid, $smarty, $mainframe;
		$c = hwd_vs_Config::get_instance();

		// load the menu name
		jimport( 'joomla.application.menu' );
		$menu   = &JMenu::getInstance('site');
		$active = &$menu->getActive();
		if (!empty($active->name)) {$metatitle = $active->name;} else {$metatitle = _HWDVIDS_META_DEFAULT;}
		// set the page/meta title
		$mainframe->setPageTitle( $metatitle." - "._HWDVIDS_META_UPLDSUC );
		$mainframe->addMetaTag( 'title' , $metatitle." - "._HWDVIDS_META_UPLDSUC );
		hwd_vs_tools::generateActiveLink(4);

		$smarty->assign("video_title", stripslashes($uploadname));
		$smarty->assign("url_upld_another", JRoute::_("index.php?option=com_hwdvideoshare&Itemid=".$Itemid."&task=upload"));
		if ($c->aav == 1) {
			$smarty->assign("video_wait_message", _HWDVIDS_INFO_VIDEOWAIT1);
		} else {
			$smarty->assign("video_wait_message", _HWDVIDS_INFO_VIDEOWAIT2);
		}



		$smarty->display('upload_local_confirm.tpl');
		return;
    }
    /**
     * Confirms video addition from third party video website
     *
     * @param string $option  the joomla component name
     * @param string $uploadname  the title of uploaded media
     * @param string $failures  list of information that failed
     *                          to be extracted from third party website
     * @return       Nothing
     */
    function addConfirm($option, $uploadname, $failures, $row)
    {
		global $mainframe, $smarty, $Itemid;
		$c = hwd_vs_Config::get_instance();
  		$db =& JFactory::getDBO();

		// load the menu name
		jimport( 'joomla.application.menu' );
		$menu   = &JMenu::getInstance('site');
		$active = &$menu->getActive();
		if (!empty($active->name)) {$metatitle = $active->name;} else {$metatitle = _HWDVIDS_META_DEFAULT;}
		// set the page/meta title
		$mainframe->setPageTitle( $metatitle." - "._HWDVIDS_META_ADDSUC );
		$mainframe->addMetaTag( 'title' , $metatitle." - "._HWDVIDS_META_ADDSUC );
		hwd_vs_tools::generateActiveLink(4);

		$smarty->assign("failures", $failures);
		$smarty->assign("thumbnail", hwd_vs_tools::generateVideoThumbnailLink($row->id, $row->video_id, $row->video_type, 0, $c->thumbwidth, $c->thumbwidth*3/4, null));
		$smarty->assign("title", stripslashes($row->title));
		$smarty->assign("description", stripslashes($row->description));
		$smarty->assign("tags", stripslashes($row->tags));
		$smarty->assign("rowid", $row->id);
		$smarty->assign("rowuid", $row->user_id);
		$smarty->assign("print_sharing", 0);
		$smarty->assign("url_upld_another", JRoute::_("index.php?option=com_hwdvideoshare&Itemid=".$Itemid."&task=upload"));
		$smarty->assign("form_save_video", JRoute::_("index.php?option=com_hwdvideoshare&Itemid=".$Itemid."&task=savevideo"));
		$smarty->assign("uploadname", stripslashes($uploadname));
		if ($c->aav == 1) {
			$smarty->assign("waitmessage", _HWDVIDS_INFO_VIDEOWAIT3);
		} else {
			$smarty->assign("waitmessage", _HWDVIDS_INFO_VIDEOWAIT2);
		}



				if ($row->public_private == "registered") {
					$smarty->assign("so1p", "");
					$smarty->assign("so1r", " selected=\"selected\"");
					$smarty->assign("so1value", "registered");
				} else if ($row->public_private == "public") {
					$smarty->assign("so1p", " selected=\"selected\"");
					$smarty->assign("so1r", "");
					$smarty->assign("so1value", "public");
				}
				if ($row->allow_comments == 0) {
					$smarty->assign("so21", "");
					$smarty->assign("so20", " selected=\"selected\"");
					$smarty->assign("so2value", "0");
				} else if ($row->allow_comments == 1) {
					$smarty->assign("so21", " selected=\"selected\"");
					$smarty->assign("so20", "");
					$smarty->assign("so2value", "1");
				}
				if ($row->allow_embedding == 0) {
					$smarty->assign("so31", "");
					$smarty->assign("so30", " selected=\"selected\"");
					$smarty->assign("so3value", "0");
				} else if ($row->allow_embedding == 1) {
					$smarty->assign("so31", " selected=\"selected\"");
					$smarty->assign("so30", "");
					$smarty->assign("so3value", "1");
				}
				if ($row->allow_ratings == 0) {
					$smarty->assign("so41", "");
					$smarty->assign("so40", " selected=\"selected\"");
					$smarty->assign("so4value", "0");
				} else if ($row->allow_ratings == 1) {
					$smarty->assign("so41", " selected=\"selected\"");
					$smarty->assign("so40", "");
					$smarty->assign("so4value", "1");
				}

			$smarty->assign("categoryselect", $categoryselectlist = hwd_vs_tools::categoryList(_HWDVIDS_INFO_CHOOSECAT, $row->category_id, _HWDVIDS_INFO_NOCATS, 1) );











		$smarty->display('upload_thirdparty_confirm.tpl');

		return;
    }
    /**
     * Constructs the video player page
     *
     * @param string $option  the joomla component name
     * @param array  $row  the array containing video information
     * @return       Nothing
     */
    function viewVideo($option, $row, $userrows, $related_videos)
    {
		global $mainframe, $Itemid, $smarty;
		$c = hwd_vs_Config::get_instance();
  		$db =& JFactory::getDBO();
		$my = & JFactory::getUser();

		// load the menu name
		jimport( 'joomla.application.menu' );
		$menu   = &JMenu::getInstance('site');
		$active = &$menu->getActive();
		if (!empty($active->name)) {$metatitle = $active->name;} else {$metatitle = _HWDVIDS_META_DEFAULT;}
		// decode
		$meta_title = html_entity_decode($row->title);
		$meta_description = html_entity_decode($row->description);
		$meta_tags = html_entity_decode($row->tags);
		// set the page/meta title
		$mainframe->setPageTitle( $metatitle." - ".$meta_title );
		$mainframe->addMetaTag( 'title' , $metatitle." - ".$meta_title );
		$mainframe->addMetaTag( 'description' , $meta_description );
		$mainframe->addMetaTag( 'keywords' , $meta_tags );
		hwd_vs_tools::generateActiveLink(1);

		$videoplayer->title = stripslashes($row->title);
		$videoplayer->player = hwd_vs_tools::generateVideoPlayer($row);
		$videoplayer->videourl = hwd_vs_tools::generateVideoUrl($row);
		$videoplayer->embedcode = hwd_vs_tools::generateEmbedCode($row);
		$videoplayer->socialbmlinks = hwd_vs_tools::generateSocialBookmarks();
		$videoplayer->comments = hwd_vs_tools::generateVideoComments($row);

		$videoplayer->editvideo = hwd_vs_tools::generateEditVideoLink($row);
		$videoplayer->deletevideo = hwd_vs_tools::generateDeleteVideoLink($row);

		if ($c->showdesc == "1") {
			$smarty->assign("print_description", 1);
			$videoplayer->description = stripslashes($row->description);
		}
		if ($c->showtags == "1") {
			$smarty->assign("print_tags", 1);
			$videoplayer->tags = stripslashes($row->tags);
		}

		if ($c->showatfb == "1") {
			$videoplayer->favourties = hwd_vs_tools::generateFavouriteButton($row);
		}

		if ($my->id && $c->showa2gb == "1") {
			$smarty->assign("print_addtogroup", 1);
			hwd_vs_javascript::ajaxaddtogroup($row);
			$videoplayer->addtogroup = hwd_vs_tools::generateAddToGroupButton($row);
		}

		$videoplayer->uploader = hwd_vs_tools::generateUserFromID($row->user_id, $row->username, $row->name);

		if ($c->showrpmb == "1") {
			hwd_vs_javascript::ajaxreportmedia($row);
			$videoplayer->reportmedia = hwd_vs_tools::generateReportMediaButton($row);
		}

		if ($c->showrate == "1") {
			hwd_vs_javascript::ajaxreportmedia($row);
			$videoplayer->ratingsystem = hwd_vs_tools::generateRatingSystem($row);
		}

		if ($row->video_type == "local" || $row->video_type == "swf") {
			if ($c->showdlor == "1") {
				$videoplayer->downloadoriginal = hwd_vs_tools::generateDownloadVideoLink($row, 1);
			}
			if ($c->showdlfl == "1") {
				$videoplayer->downloadflv = hwd_vs_tools::generateDownloadVideoLink($row, 0);
			}
		} else {
			if ($c->showvuor == "1") {
				$videoplayer->vieworiginal = hwd_vs_tools::generateViewOriginalLink($row);
			}
		}

		if ($c->showprnx == "1") {
			$smarty->assign("print_nextprev", 1);
			$videoplayer->nextprev = hwd_vs_tools::generateNextPrevLinks($row);
		}


		if (count($related_videos) > 0 && $c->showrevi == "1") {
			$smarty->assign("print_relatedlist", 1);
			$listrelated = hwd_vs_tools::generateVideoListFromSql($related_videos, "", "50", "38");
			$smarty->assign("listrelated", $listrelated);
		}



		$videoplayer->customad1 = "";
		$videoplayer->customad2 = "";
		$videoplayer->customad3 = "";
		$videoplayer->morebyuser = "";

		if ($c->cbint == "1" || $c->cbint == "2") {

			$videoplayer->avatar = hwd_vs_tools::generateAvatar($row->user_id, $row->avatar, 0, null, null, null);

		}


		$videoplayer->views = $row->number_of_views;;
		$videoplayer->category = hwd_vs_tools::generateCategoryLink($row->category_id);;
		$videoplayer->upload_date = $row->date_uploaded;

		$smarty->assign("videoplayer", $videoplayer);


		if (count($userrows) > 0 && $c->showuldr == "1") {
			$smarty->assign("print_uservideolist", 1);
			$userlist = hwd_vs_tools::generateVideoListFromSql($userrows, "", "50", "38");
			$smarty->assign("userlist", $userlist);
		} else {
			$smarty->assign("userlist", "This user does not have any other videos.");
		}






		$smarty->display('video_player.tpl');

		return;
    }
    /**
     * Lists all available categories
     *
     * @param string $option  the joomla component name
     * @param array  $row  the array containing category information
     * @return       Nothing
     */
    function categories($option, $rows)
    {
		global $Itemid, $mainframe, $smarty, $params;
		$c = hwd_vs_Config::get_instance();
		$db = & JFactory::getDBO();

		// load the menu name
		jimport( 'joomla.application.menu' );
		$menu   = &JMenu::getInstance('site');
		$active = &$menu->getActive();
		if (!empty($active->name)) {$metatitle = $active->name;} else {$metatitle = _HWDVIDS_META_DEFAULT;}
		// set the page/meta title
		$mainframe->setPageTitle( $metatitle." - "._HWDVIDS_META_CATS );
		$mainframe->addMetaTag( 'title' , $metatitle." - "._HWDVIDS_META_CATS );
		hwd_vs_tools::generateActiveLink(2);

		$k = 0;
		if (count($rows) > 0) {
			$smarty->assign("print_categories", 1);
			$z = 0;
			for ($i=0, $m=count($rows); $i < $m; $i++) {
				$row = $rows[$i];
				$list[$z]->level = 0;
				$list[$z]->thumbnail = hwd_vs_tools::generateCategoryThumbnailLink( $row, $k, $c->thumbwidth, $c->thumbwidth*3/4, null);
				$list[$z]->title = hwd_vs_tools::generateCategoryLink($row->id, $row->category_name);
				$list[$z]->num_vids = $row->num_vids;
				$list[$z]->num_subcats = $row->num_subcats;
				$list[$z]->description = hwd_vs_tools::truncateText($row->category_description, $c->trunvdesc);
				$list[$z]->k = $k;
				$k = 1 - $k;

				$query = 'SELECT *'
						. ' FROM #__hwdvidscategories'
						. ' WHERE published = 1'
						. ' AND parent = '.$row->id
						. ' ORDER BY ordering, category_name'
						;
				$db->setQuery( $query );
				$subs1 = $db->loadObjectList();
				if (count($subs1) > 0) {
					for ($j=0, $n=count($subs1); $j < $n; $j++) {
						$z++;
						$sub1 = $subs1[$j];
						$list[$z]->level = 1;
						$list[$z]->thumbnail = hwd_vs_tools::generateCategoryThumbnailLink($sub1, $k, $c->thumbwidth, $c->thumbwidth*3/4, null);
						$list[$z]->title = hwd_vs_tools::generateCategoryLink($sub1->id, $sub1->category_name);
						$list[$z]->num_vids = $sub1->num_vids;
						$list[$z]->num_subcats = $sub1->num_subcats;
						$list[$z]->description = null;
						$list[$z]->k = $k;
						$k = 1 - $k;

						$query = 'SELECT *'
								. ' FROM #__hwdvidscategories'
								. ' WHERE published = 1'
								. ' AND parent = '.$sub1->id
								. ' ORDER BY ordering, category_name'
								;
						$db->setQuery( $query );
						$subs2 = $db->loadObjectList();
						if (count($subs2) > 0) {
							for ($l=0, $o=count($subs2); $l < $o; $l++) {
								$z++;
								$sub2 = $subs2[$l];
								$list[$z]->level = 2;
								$list[$z]->thumbnail = null;
								$list[$z]->title = hwd_vs_tools::generateCategoryLink($sub2->id, $sub2->category_name);
								$list[$z]->num_vids = $sub2->num_vids;
								$list[$z]->num_subcats = $sub2->num_subcats;
								$list[$z]->description = null;
								$list[$z]->k = $k;
								$k = 1 - $k;
							}
						}
					}
				}
			$z++;
			}
			$smarty->assign("list", $list);
		}
		$smarty->display('category_index.tpl');
		return;


    }
    /**
     * Constructs the category page and lists all category videos
     *
     * @param string $option  the joomla component name
     * @param array  $rows  the array containing video information
     * @param object $pageNav  the page navigation object
     * @param int    $total  the total category video count
     * @param int    $cat_id  the id of the category
     * @param array  $cat  the array containing category information
     * @return       Nothing
     */
    function viewCategory($option, $rows, $pageNav, $total, $cat_id, $cat, $subcats)
    {
    	global $Itemid, $smarty, $mainframe;
		$c = hwd_vs_Config::get_instance();
		if ($c->showrating == 1 || $c->showviews == 1 || $c->showduration == 1 || $c->showuplder == 1) { $infowidth = 150; } else { $infowidth = 0; }

		// load the menu name
		jimport( 'joomla.application.menu' );
		$menu   = &JMenu::getInstance('site');
		$active = &$menu->getActive();
		if (!empty($active->name)) {$metatitle = $active->name;} else {$metatitle = _HWDVIDS_META_DEFAULT;}
		// set the page/meta title
		$mainframe->setPageTitle( $metatitle." - "._HWDVIDS_META_CATS." - ".$cat->category_name );
		$mainframe->addMetaTag( 'title' , $metatitle." - "._HWDVIDS_META_CATS." - ".$cat->category_name );
		hwd_vs_tools::generateActiveLink(2);

		$smarty->assign("category_name", $cat->category_name);

		if (count($rows) > 0) {
			$smarty->assign("print_videolist", 1);
			$list = hwd_vs_tools::generateVideoListFromSql($rows);
			$smarty->assign("list", $list);
		}

		$page = $total - $c->vpp;
		$pageNavigation = null;
		if ( $page > 0 ) {
			$link = "index.php?option=com_hwdvideoshare&task=viewcategory&cat_id=".$cat_id."&Itemid=".$Itemid;
			$pageNavigation.= "<div class=\"pagenavi\" align=\"center\">";
			$pageNavigation.= $pageNav->writePagesLinks($link);
			$pageNavigation.= "<div class=\"pagecount\">".$pageNav->writePagesCounter()."</div>";
			$pageNavigation.= "</div>";
		}
		$smarty->assign("pageNavigation", $pageNavigation);

		if (count($subcats) > 0) {
			$smarty->assign("print_subcats", 1);

			$k=0;
			for ($i=0, $m=count($subcats); $i < $m; $i++) {
				$row = $subcats[$i];
				$subcatlist[$i]->level = 0;
				$subcatlist[$i]->thumbnail = hwd_vs_tools::generateCategoryThumbnailLink( $row, $k, $c->thumbwidth, $c->thumbwidth*3/4, null);
				$subcatlist[$i]->title = hwd_vs_tools::generateCategoryLink($row->id, $row->category_name);
				$subcatlist[$i]->num_vids = $row->num_vids;
				$subcatlist[$i]->num_subcats = $row->num_subcats;
				$subcatlist[$i]->description = hwd_vs_tools::truncateText($row->category_description, $c->trunvdesc);
				$subcatlist[$i]->k = $k;
				$k = 1 - $k;
			}
			$smarty->assign("subcatlist", $subcatlist);
		}

		$smarty->display('category_view.tpl');
		return;
    }
    /**
     * Constructs the group list page and lists all groups
     *
     * @param string $option  the joomla component name
     * @param array  $rows  the array containing group information
     * @param array  $rowsfeatured  the array containing featured group information
     * @param object $pageNav  the page navigation object
     * @param int    $total  the total group count
     * @return       Nothing
     */
    function groups($option, $rows, $rowsfeatured, $pageNav, $total)
    {
		global $Itemid, $mainframe, $smarty, $params;
		$c = hwd_vs_Config::get_instance();

		// load the menu name
		jimport( 'joomla.application.menu' );
		$menu   = &JMenu::getInstance('site');
		$active = &$menu->getActive();
		if (!empty($active->name)) {$metatitle = $active->name;} else {$metatitle = _HWDVIDS_META_DEFAULT;}
		// set the page/meta title
		$mainframe->setPageTitle( $metatitle." - "._HWDVIDS_META_GRPS );
		$mainframe->addMetaTag( 'title' , $metatitle." - "._HWDVIDS_META_GRPS );
		hwd_vs_tools::generateActiveLink(3);
		// define javascript
		hwd_vs_javascript::confirmdelete();

		$k = 0;
		if (count($rowsfeatured) > 0) {
			$smarty->assign("print_featured", 1);
			$featuredlist = hwd_vs_tools::generateGroupListFromSql($rowsfeatured);
			$smarty->assign("featuredlist", $featuredlist);
		}

		if (count($rows) > 0) {
			$smarty->assign("print_grouplist", 1);
			$list = hwd_vs_tools::generateGroupListFromSql($rows);
			$smarty->assign("list", $list);
		}

		$page = $total - $c->gpp;
		$pageNavigation = null;
		if ( $page > 0 ) {
			$link = "index.php?option=com_hwdvideoshare&Itemid=".$Itemid."&task=groups";
			$pageNavigation.= "<div class=\"pagenavi\" align=\"center\">";
			$pageNavigation.= $pageNav->writePagesLinks($link);
			$pageNavigation.= "<div class=\"pagecount\">".$pageNav->writePagesCounter()."</div>";
			$pageNavigation.= "</div>";
		}
		$smarty->assign("pageNavigation", $pageNavigation);

		$smarty->assign( "featured_link" , JRoute::_("index.php?option=com_hwdvideoshare&Itemid=".$Itemid."&task=featuredgroups")  );

		$smarty->display('group_index.tpl');
		return;
    }
    /**
     * Constructs the new group form
     *
     * @param string $option  the joomla component name
     * @return       Nothing
     */
    function createGroup($option)
    {
		global $mainframe, $Itemid, $smarty, $option, $Itemid;
		$c = hwd_vs_Config::get_instance();

		// load the menu name
		jimport( 'joomla.application.menu' );
		$menu   = &JMenu::getInstance('site');
		$active = &$menu->getActive();
		if (!empty($active->name)) {$metatitle = $active->name;} else {$metatitle = _HWDVIDS_META_DEFAULT;}
		// set the page/meta title
		$mainframe->setPageTitle( $metatitle." - "._HWDVIDS_META_NGRPS );
		$mainframe->addMetaTag( 'title' , $metatitle." - "._HWDVIDS_META_NGRPS );
		hwd_vs_tools::generateActiveLink(3);
		// define javascript
		hwd_vs_javascript::checkaddgroupform();

		$form_add_group = JRoute::_("index.php?option=com_hwdvideoshare&Itemid=".$Itemid."&task=savegroup");
		$smarty->assign("form_add_group", $form_add_group);
		$captcha = hwd_vs_tools::generateCaptcha();
		$smarty->assign("captcha", $captcha);

		$smarty->display('group_add.tpl');
		return;
    }
    /**
     * Constructs the group page and lists all containing group videos
     *
     * @param string $option  the joomla component name
     * @param array  $rows  the array containing video information
     * @param object $pageNav  the page navigation object
     * @param int    $total  the total video count
     * @param array  $groupdetails  the array containing group information
     * @return       Nothing
     */
    function viewGroup($option, $rows, $pageNav, $total, $members, $groupdetails)
    {
		global $mainframe, $Itemid, $smarty;
		$c = hwd_vs_Config::get_instance();

		if ($c->showrating == 1 || $c->showviews == 1 || $c->showduration == 1 || $c->showuplder == 1) { $infowidth = 150; } else { $infowidth = 0; }
		// load the menu name
		jimport( 'joomla.application.menu' );
		$menu   = &JMenu::getInstance('site');
		$active = &$menu->getActive();
		if (!empty($active->name)) {$metatitle = $active->name;} else {$metatitle = _HWDVIDS_META_DEFAULT;}
		// set the page/meta title
		$mainframe->setPageTitle( $metatitle." - "._HWDVIDS_META_GRPS." - ".$groupdetails->group_name );
		$mainframe->addMetaTag( 'title' , $metatitle." - "._HWDVIDS_META_GRPS." - ".$groupdetails->group_name );
		hwd_vs_tools::generateActiveLink(3);

		$smarty->assign("group_name", stripslashes($groupdetails->group_name));
		$smarty->assign("group_description", stripslashes($groupdetails->group_description));


		$group->totalmembers = $groupdetails->total_members;
		$group->totalvideos = $groupdetails->total_videos;
		$group->administrator = hwd_vs_tools::generateUserFromID($groupdetails->adminid, $groupdetails->username, $groupdetails->name);


		$group->groupmembership = hwd_vs_tools::generateGroupMembershipStatus($groupdetails);
		$group->reportgroup = hwd_vs_tools::generateReportGroupButton($groupdetails);
		$group->deletegroup = hwd_vs_tools::generateDeleteGroupButton($groupdetails);
		$group->editgroup = hwd_vs_tools::generateEditGroupButton($groupdetails);

		$smarty->assign("group", $group);




		if (count($members) > 0) {
			$smarty->assign("print_memberslist", 1);

			for ($i=0, $n=count($members); $i < $n; $i++) {
				$row = $members[$i];
				$memberslist[$i]->id = $row->id;
				$memberslist[$i]->username = $row->username;
			}

			$smarty->assign("memberslist", $memberslist);
		}



		if (count($rows) > 0) {
			$smarty->assign("print_videolist", 1);
			$list = hwd_vs_tools::generateVideoListFromSql($rows);
			$smarty->assign("list", $list);
		}



		$page = $total - $c->vpp;
		$pageNavigation = null;
		if ( $page > 0 ) {
				$link = "index.php?option=com_hwdvideoshare&Itemid=".$Itemid."&task=viewgroup&group_id=".$groupdetails->id;
			$pageNavigation.= "<div class=\"pagenavi\" align=\"center\">";
			$pageNavigation.= $pageNav->writePagesLinks($link);
			$pageNavigation.= "<div class=\"pagecount\">".$pageNav->writePagesCounter()."</div>";
			$pageNavigation.= "</div>";
		}
		$smarty->assign("pageNavigation", $pageNavigation);











		$group->comments = hwd_vs_tools::generateGroupComments($groupdetails);

		$smarty->display('group_view.tpl');
		return;



    }
    /**
     * Constructs a video list of all user videos
     *
     * @param string $option  the joomla component name
     * @param array  $rows  the array containing video information
     * @param object $pageNav  the page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
    function yourVideos($option, $rows, $pageNav, $total)
    {
		global $smarty, $Itemid, $mainframe;
		$c = hwd_vs_Config::get_instance();

		if ($c->showrating == 1 || $c->showviews == 1 || $c->showduration == 1 || $c->showuplder == 1) { $infowidth = 150; } else { $infowidth = 0; }
		// load the menu name
		jimport( 'joomla.application.menu' );
		$menu   = &JMenu::getInstance('site');
		$active = &$menu->getActive();
		if (!empty($active->name)) {$metatitle = $active->name;} else {$metatitle = _HWDVIDS_META_DEFAULT;}
		// set the page/meta title
		$mainframe->setPageTitle( $metatitle." - "._HWDVIDS_META_YVIDS );
		$mainframe->addMetaTag( 'title' , $metatitle." - "._HWDVIDS_META_YVIDS );
		hwd_vs_tools::generateActiveLink(1);

		if (count($rows) > 0) {
			$smarty->assign("print_videolist", 1);
			$list = hwd_vs_tools::generateVideoListFromSql($rows);
			$smarty->assign("list", $list);
		}

		$page = $total - $c->vpp;
		$pageNavigation = null;
		if ( $page > 0 ) {
			$link = "index.php?option=com_hwdvideoshare&task=yourvids&Itemid=".$Itemid;
			$pageNavigation.= "<div class=\"pagenavi\" align=\"center\">";
			$pageNavigation.= $pageNav->writePagesLinks($link);
			$pageNavigation.= "<div class=\"pagecount\">".$pageNav->writePagesCounter()."</div>";
			$pageNavigation.= "</div>";
		}
		$smarty->assign("pageNavigation", $pageNavigation);

		$smarty->display('video_yourvideos.tpl');
		return;
    }
    /**
     * Constructs a video list of all user favourite videos
     *
     * @param string $option  the joomla component name
     * @param array  $rows  the array containing video information
     * @param object $pageNav  the page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
    function yourFavourites($option, $rows, $pageNav, $total)
    {
		global $Itemid, $smarty, $mainframe;
		$c = hwd_vs_Config::get_instance();

		if ($c->showrating == 1 || $c->showviews == 1 || $c->showduration == 1 || $c->showuplder == 1) { $infowidth = 150; } else { $infowidth = 0; }
		// load the menu name
		jimport( 'joomla.application.menu' );
		$menu   = &JMenu::getInstance('site');
		$active = &$menu->getActive();
		if (!empty($active->name)) {$metatitle = $active->name;} else {$metatitle = _HWDVIDS_META_DEFAULT;}
		// set the page/meta title
		$mainframe->setPageTitle( $metatitle." - "._HWDVIDS_META_YFAVS );
		$mainframe->addMetaTag( 'title' , $metatitle." - "._HWDVIDS_META_YFAVS );
		hwd_vs_tools::generateActiveLink(1);

		if (count($rows) > 0) {
			$smarty->assign("print_videolist", 1);
			$list = hwd_vs_tools::generateVideoListFromSql($rows);
			$smarty->assign("list", $list);
		}

		$page = $total - $c->vpp;
		$pageNavigation = null;
		if ( $page > 0 ) {
			$link = "index.php?option=com_hwdvideoshare&task=yourfavs&Itemid=".$Itemid;
			$pageNavigation.= "<div class=\"pagenavi\" align=\"center\">";
			$pageNavigation.= $pageNav->writePagesLinks($link);
			$pageNavigation.= "<div class=\"pagecount\">".$pageNav->writePagesCounter()."</div>";
			$pageNavigation.= "</div>";
		}
		$smarty->assign("pageNavigation", $pageNavigation);

		$smarty->display('video_yourfavourites.tpl');
		return;

    }
    /**
     * Constructs a video list of all featured videos
     *
     * @param string $option  the joomla component name
     * @param array  $rows  the array containing video information
     * @param object $pageNav  the page navigation object
     * @param int    $total  the total video count
     * @return       Nothing
     */
    function featuredVideos($option, $rows, $pageNav, $total)
    {
		global $Itemid, $smarty, $mainframe;
		$c = hwd_vs_Config::get_instance();

		// load the menu name
		jimport( 'joomla.application.menu' );
		$menu   = &JMenu::getInstance('site');
		$active = &$menu->getActive();
		if (!empty($active->name)) {$metatitle = $active->name;} else {$metatitle = _HWDVIDS_META_DEFAULT;}
		// set the page/meta title
		$mainframe->setPageTitle( $metatitle." - "._HWDVIDS_META_FEATU );
		$mainframe->addMetaTag( 'title' , $metatitle." - "._HWDVIDS_META_FEATU );
		hwd_vs_tools::generateActiveLink(1);

		if (count($rows) > 0) {
			$smarty->assign("print_videolist", 1);
			$list = hwd_vs_tools::generateVideoListFromSql($rows);
			$smarty->assign("list", $list);
		}

		$page = $total - $c->vpp;
		$pageNavigation = null;
		if ( $page > 0 ) {
			$link = "index.php?option=com_hwdvideoshare&task=featuredvids&Itemid=".$Itemid;
			$pageNavigation.= "<div class=\"pagenavi\" align=\"center\">";
			$pageNavigation.= $pageNav->writePagesLinks($link);
			$pageNavigation.= "<div class=\"pagecount\">".$pageNav->writePagesCounter()."</div>";
			$pageNavigation.= "</div>";
		}
		$smarty->assign("pageNavigation", $pageNavigation);

		$smarty->display('video_featuredvideos.tpl');
		return;
    }
    /**
     * Constructs a group list of all user groups
     *
     * @param string $option  the joomla component name
     * @param array  $rows  the array containing group information
     * @param object $pageNav  the page navigation object
     * @param int    $total  the total group count
     * @return       Nothing
     */
    function yourGroups($option, $rows, $pageNav, $total)
    {
		global $Itemid, $smarty, $mainframe;
		$c = hwd_vs_Config::get_instance();

		// load the menu name
		jimport( 'joomla.application.menu' );
		$menu   = &JMenu::getInstance('site');
		$active = &$menu->getActive();
		if (!empty($active->name)) {$metatitle = $active->name;} else {$metatitle = _HWDVIDS_META_DEFAULT;}
		// set the page/meta title
		$mainframe->setPageTitle( $metatitle." - "._HWDVIDS_META_YGRPS );
		$mainframe->addMetaTag( 'title' , $metatitle." - "._HWDVIDS_META_YGRPS );
		hwd_vs_tools::generateActiveLink(3);

		if (count($rows) > 0) {
			$smarty->assign("print_grouplist", 1);
			$list = hwd_vs_tools::generateGroupListFromSql($rows);
			$smarty->assign("list", $list);
		}

		$page = $total - $c->vpp;
		$pageNavigation = null;
		if ( $page > 0 ) {
					$link = "index.php?option=com_hwdvideoshare&task=yourgroups&Itemid=".$Itemid;
			$pageNavigation.= "<div class=\"pagenavi\" align=\"center\">";
			$pageNavigation.= $pageNav->writePagesLinks($link);
			$pageNavigation.= "<div class=\"pagecount\">".$pageNav->writePagesCounter()."</div>";
			$pageNavigation.= "</div>";
		}
		$smarty->assign("pageNavigation", $pageNavigation);

		$smarty->display('group_yourgroups.tpl');
		return;
    }
    /**
     * Constructs a group list of all user group memberships
     *
     * @param string $option  the joomla component name
     * @param array  $rows  the array containing group information
     * @param object $pageNav  the page navigation object
     * @param int    $total  the total group count
     * @return       Nothing
     */
    function yourMemberships($option, $rows, $pageNav, $total)
    {
		global $Itemid, $smarty, $mainframe;
		$c = hwd_vs_Config::get_instance();

		// load the menu name
		jimport( 'joomla.application.menu' );
		$menu   = &JMenu::getInstance('site');
		$active = &$menu->getActive();
		if (!empty($active->name)) {$metatitle = $active->name;} else {$metatitle = _HWDVIDS_META_DEFAULT;}
		// set the page/meta title
		$mainframe->setPageTitle( $metatitle." - "._HWDVIDS_META_YGRPM );
		$mainframe->addMetaTag( 'title' , $metatitle." - "._HWDVIDS_META_YGRPM );
		hwd_vs_tools::generateActiveLink(3);

		if (count($rows) > 0) {
			$smarty->assign("print_grouplist", 1);
			$list = hwd_vs_tools::generateGroupListFromSql($rows);
			$smarty->assign("list", $list);
		}

		$page = $total - $c->vpp;
		$pageNavigation = null;
		if ( $page > 0 ) {
					$link = "index.php?option=com_hwdvideoshare&task=yourmemberships&Itemid=".$Itemid;
			$pageNavigation.= "<div class=\"pagenavi\" align=\"center\">";
			$pageNavigation.= $pageNav->writePagesLinks($link);
			$pageNavigation.= "<div class=\"pagecount\">".$pageNav->writePagesCounter()."</div>";
			$pageNavigation.= "</div>";
		}
		$smarty->assign("pageNavigation", $pageNavigation);

		$smarty->display('group_yourgroupmemberships.tpl');
		return;
    }
    /**
     * Constructs a group list of all featured groups
     *
     * @param string $option  the joomla component name
     * @param array  $rows  the array containing group information
     * @param object $pageNav  the page navigation object
     * @param int    $total  the total group count
     * @return       Nothing
     */
    function featuredGroups($option, $rows, $pageNav, $total)
    {
		global $Itemid, $smarty, $mainframe;
		$c = hwd_vs_Config::get_instance();

		// load the menu name
		jimport( 'joomla.application.menu' );
		$menu   = &JMenu::getInstance('site');
		$active = &$menu->getActive();
		if (!empty($active->name)) {$metatitle = $active->name;} else {$metatitle = _HWDVIDS_META_DEFAULT;}
		// set the page/meta title
		$mainframe->setPageTitle( $metatitle." - "._HWDVIDS_META_FEATG );
		$mainframe->addMetaTag( 'title' , $metatitle." - "._HWDVIDS_META_FEATG );
		hwd_vs_tools::generateActiveLink(3);

		if (count($rows) > 0) {
			$smarty->assign("print_grouplist", 1);
			$list = hwd_vs_tools::generateGroupListFromSql($rows);
			$smarty->assign("list", $list);
		}

		$page = $total - $c->vpp;
		$pageNavigation = null;
		if ( $page > 0 ) {
					$link = "index.php?option=com_hwdvideoshare&task=featuredvids&Itemid=".$Itemid."&task=featuredgroups";
			$pageNavigation.= "<div class=\"pagenavi\" align=\"center\">";
			$pageNavigation.= $pageNav->writePagesLinks($link);
			$pageNavigation.= "<div class=\"pagecount\">".$pageNav->writePagesCounter()."</div>";
			$pageNavigation.= "</div>";
		}
		$smarty->assign("pageNavigation", $pageNavigation);

		$smarty->display('group_featuredgroups.tpl');
		return;
    }
    /**
     * Loads video data to edit
     *
     * @param string $option  the joomla component name
     * @param array  $row  the array containing video information
     * @return       Nothing
     */
    function editVideoInfo($option, $row)
    {
    	global $mainframe, $Itemid, $smarty, $option, $Itemid;
        $c = hwd_vs_Config::get_instance();

		// load the menu name
		jimport( 'joomla.application.menu' );
		$menu   = &JMenu::getInstance('site');
		$active = &$menu->getActive();
		if (!empty($active->name)) {$metatitle = $active->name;} else {$metatitle = _HWDVIDS_META_DEFAULT;}
        // decode
        $meta_title = html_entity_decode($row->title);
        // set the page/meta title
        $mainframe->setPageTitle( $metatitle." - "._HWDVIDS_META_EVIDS." - ".$meta_title );
        $mainframe->addMetaTag( 'title' , $metatitle." - "._HWDVIDS_META_EVIDS." - ".$meta_title );
		hwd_vs_tools::generateActiveLink(1);
		// define javascript
			hwd_vs_javascript::checkuploadform();

			$smarty->assign("thumbnail", hwd_vs_tools::generateVideoThumbnailLink($row->id, $row->video_id, $row->video_type, 0, null, null, null));
			$smarty->assign("title", stripslashes($row->title));
			$smarty->assign("description", stripslashes($row->description));
			$smarty->assign("tags", stripslashes($row->tags));
			$smarty->assign("rowid", $row->id);
			$smarty->assign("rowuid", $row->user_id);
			$smarty->assign("print_sharingoptions", 1);
		$smarty->assign("form_save_video", JRoute::_("index.php?option=com_hwdvideoshare&Itemid=".$Itemid."&task=savevideo"));

				if ($row->public_private == "registered") {
					$smarty->assign("so1p", "");
					$smarty->assign("so1r", " selected=\"selected\"");
					$smarty->assign("so1value", "registered");
				} else if ($row->public_private == "public") {
					$smarty->assign("so1p", " selected=\"selected\"");
					$smarty->assign("so1r", "");
					$smarty->assign("so1value", "public");
				}
				if ($row->allow_comments == 0) {
					$smarty->assign("so21", "");
					$smarty->assign("so20", " selected=\"selected\"");
					$smarty->assign("so2value", "0");
				} else if ($row->allow_comments == 1) {
					$smarty->assign("so21", " selected=\"selected\"");
					$smarty->assign("so20", "");
					$smarty->assign("so2value", "1");
				}
				if ($row->allow_embedding == 0) {
					$smarty->assign("so31", "");
					$smarty->assign("so30", " selected=\"selected\"");
					$smarty->assign("so3value", "0");
				} else if ($row->allow_embedding == 1) {
					$smarty->assign("so31", " selected=\"selected\"");
					$smarty->assign("so30", "");
					$smarty->assign("so3value", "1");
				}
				if ($row->allow_ratings == 0) {
					$smarty->assign("so41", "");
					$smarty->assign("so40", " selected=\"selected\"");
					$smarty->assign("so4value", "0");
				} else if ($row->allow_ratings == 1) {
					$smarty->assign("so41", " selected=\"selected\"");
					$smarty->assign("so40", "");
					$smarty->assign("so4value", "1");
				}

			$smarty->assign("categoryselect", $categoryselectlist = hwd_vs_tools::categoryList(_HWDVIDS_INFO_CHOOSECAT, $row->category_id, _HWDVIDS_INFO_NOCATS, 1) );


		$smarty->display('video_edit.tpl');
		return;
    }
    /**
     * Loads group data to edit
     *
     * @param string $option  the joomla component name
     * @param array  $row  the array containing group information
     * @return       Nothing
     */
    function editGroupInfo($option, $row, $grp_members)
    {
    	global $mainframe, $Itemid, $smarty, $option, $Itemid;
        $c = hwd_vs_Config::get_instance();

		// load the menu name
		jimport( 'joomla.application.menu' );
		$menu   = &JMenu::getInstance('site');
		$active = &$menu->getActive();
		if (!empty($active->name)) {$metatitle = $active->name;} else {$metatitle = _HWDVIDS_META_DEFAULT;}
        // decode
        $meta_title = html_entity_decode($row->group_name);
        // set the page/meta title
        $mainframe->setPageTitle( $metatitle." - "._HWDVIDS_META_EVIDS." - ".$meta_title );
        $mainframe->addMetaTag( 'title' , $metatitle." - "._HWDVIDS_META_EVIDS." - ".$meta_title );
		hwd_vs_tools::generateActiveLink(3);
		// define javascript
		hwd_vs_javascript::confirmdelete();

			$smarty->assign("title", stripslashes($row->group_name));
			$smarty->assign("description", stripslashes($row->group_description));
			$smarty->assign("rowid", $row->id);
			$smarty->assign("rowuid", $row->adminid);


		if (count($grp_members) > 0) {
			$smarty->assign("print_grp_members", 1);
			$grp_memberlist = hwd_vs_tools::generateGroupMemberList($grp_members);
			$smarty->assign("grp_memberlist", $grp_memberlist);
		}
		//echo count ($grp_members);



		$smarty->display('group_edit.tpl');
		return;
    }
}
?>