<?php
/**
 * @version 2.0.1
 * @package moseasymedia
 * @copyright Copyright &copy; 2008, Brilaps LLC
 * @author Ozgur Cem Sen
 * @email code@brilaps.com
 * @link http://brilaps.com || http://wiki.brilaps.com
 * @license http://www.opensource.org/licenses/gpl-license.php GNU/GPL v.2 .
 */


class cmoseasymediaXSPFPlayer extends cmoseasymediaEmbed {
	/**
	 * Function for embedding the audio files associated with XSPFPlayer
	 * @return string formatted HTML embed string
	 *`
	 * http://musicplayer.sourceforge.net/
	 * moseasymedia supports only playlists with XSPF player. please check other means of playing single mp3 files.
	 * autoload, autoplay attributes are not functional.
	 */
	function moseasymediaXSPFPlayer() {
		 
		global $MOSEASYMEDIA_BASE_URL;
		$embedString = "";
		if ($this->moseasymediaparams->get("ocsmem_modeXSPFPlayer", "") == "extended")
		$player_swf = 'players/xspf_player.swf';
		else
		$player_swf = 'players/xspf_player_slim.swf';
		//the following arrays will serve as attributes to be populated by the $this->moseasymediaparams
		$object_attributes = array('id', 'classid', 'codebase', 'standby', 'type', 'width', 'height');
		$object_attribute_values = moseasymediaPlayerEngine::generateAttributeValuesArray($this->player, $object_attributes, $this->moseasymediaparams, TRUE);
		//additional..
		$object_attribute_values['id'] = $this->uniqueID;
	
		 
		$XSPF_QueryString_attributes = array('autoplay', 'autoload', 'repeat_playlist', 'player_title', 'info_button_text', 'radio_mode','playlist_size');
		//$XSPF_QueryString_attributes = array();
		$XSPF_QueryString_attribut_values = moseasymediaPlayerEngine::generateAttributeValuesArray($this->player, $XSPF_QueryString_attributes, $this->moseasymediaparams, TRUE);
		 
		//if you'want to play a single MP3, makes sure that you set the singlefile=true  in the {moseasymedia .... }
		$XSPF_QueryString_attribut_values['playlist_url'] = $this->mediaPath ;
		$strXSPF_QueryString = $MOSEASYMEDIA_BASE_URL.$player_swf."?";
		foreach ($XSPF_QueryString_attribut_values as $k=>$v) {
			if (strlen(trim($v))> 0)
			$strXSPF_QueryString .= '&'.$k.'='.$v;
		}
		 
		$param_attributes = array('src', 'width', 'height');
		$param_attribute_values = moseasymediaPlayerEngine::generateAttributeValuesArray($this->player, $param_attributes, $this->moseasymediaparams, TRUE);
		$param_attribute_values['movie'] = $strXSPF_QueryString;
	
	
		$embed_atrributes = array('name', 'id', 'src', 'width', 'height', 'type', 'pluginspage');
		$embed_attribute_values = moseasymediaPlayerEngine::generateAttributeValuesArray($this->player, $embed_atrributes, $this->moseasymediaparams, TRUE);
		//additional..
		$embed_attribute_values['src'] = $strXSPF_QueryString;
		$embed_attribute_values['name'] = $this->uniqueID;
		$embed_attribute_values['id'] = $this->uniqueID;
		 
		 
		//THE KEY TO EVERYTHING IN moseasymedia
		$strMediaEmbedCode = moseasymediaPlayerEngine::generateObjectParamEmbedCode($object_attribute_values, $param_attribute_values, $embed_attribute_values);
	
		//Check to see if we're using object embedding or javascript
		if ((int)$this->moseasymediaparams->get("ocsmem_UseJavascript$this->player") == 0) {
			$embedString .= $strMediaEmbedCode;
		}
		else {
			$embedString = '<script src="'.$MOSEASYMEDIA_BASE_URL.'js/dreadedActiveX.js" type="text/javascript"></script>';			
			$escapedEmbed = cmoseasymediaEmbed::getEscaped($strMediaEmbedCode);
			$embedString .= '<script type="text/javascript">';
			$embedString .= '   embedObject("'.$escapedEmbed.'");';
			$embedString .= '</script>';
		}
		$embedString .= '</div>';
		$embedString .= '<!-- moseasymedia -->' ;

		if ($this->moseasymediaparams->get("ocsmem_Popup_popup", "none") === "none") {
			$embedString = $this->getHeader().$embedString.$this->getFooter();
		}
		else {	
			if (($this->moseasymediaparams->get("ocsmem_Popup_popup", "none") === "window") &&  
					($this->moseasymediaparams->get("ocsmem_Popup_popupmediathumbnail", "none") === "none"))
				$embedString = $this->getHeader().$embedString.$this->popupCode($embedString.$this->getFooter()).$this->getFooter();
			else 
				$embedString = $this->getHeader().$this->popupCode($embedString.$this->getFooter()).$this->getFooter();
		}
				
		return $embedString;
	}
}
?>
